//просмотр справки в пенсионный фонд помесячной
include("gridedit.js");
include("Objects/DpGetDat.js");
include("servis/format.js");
include("r_comp13.js");
include("servis/date.js");
include("get_const.js");
include("sys/udfs.js");
var sortMode = "Ftt,FTABNN";
var Ftabn_id = 0;
var isDblInd = false;
var dblColor = 17;
var gd, szTag, zppnm6, zppnm7, zppnm7d, menuMode;

function listLoad()
{
	gd = new DpGetDat("d");
	if(gd.escape)
		return false;
	szTag = getDateTag(gd.dat1);
	zppnm6 = "^ZPPFMVI"+szTag;
	this.printLabel = "COMP";
	menuMode = GetMenuMode();
	if(menuMode!="CALC")
	{
		if (!IsTableEx("ZRP_RES","ZRP_ZPPFMVI"+szTag))
		{
			alert(ru("Cначала сделайте расчет таблицы 6 за ",	"Спочатку виконайте розрахунок таблицi 6 за ")+format("Mmm yyyy",gd.dat1).toLowerCase());
			return false;
		}
		this.title = UR("Перегляд 6 таблиці - |Просмотр 6 таблицы - ")+format("Mmm yyyy",gd.dat1).toLowerCase();
	}
	else
	{
		var msg = ru("Таблица 6 уже расчитана за ",
				"Таблиця 6 вже розрахована за ")+format("Mmm yyyy",gd.dat1).toLowerCase()+"\n"+ru("Продолжить расчет?","Продовжити розрахунок?");
		if (IsTableEx("ZRP_RES","ZRP_ZPPFMVI"+szTag) && !confirm(msg))
			return false;
		var par=new Object();
//		par.sysname = getSysName();
//		par.escape = false;
		par.xyear = gd.dat1;		
//	    par.typ1 = true;
//	    par.typ2 = false;
//	    par.sdatr = today.getVarDate();
//		par._KPFU = "";
//		par._KTSZ = "0";
//	    
//		showWindow("e_zsprpnm.xml", SW_MODAL, par);	
//		setParWithDef("DAT1_P", par.xyear, par.sysname);
//		if (par.escape)
//			return false;

		this.title = UR("Розрахунок персоніфікації 6 таблиця - | Расчет персонификации 6 таблица - ")+format("Mmm yyyy",gd.dat1).toLowerCase();
	
		r_comp13(par);
	}
	
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
	var snap = getSnap("select count(*) from "+zppnm6+" where Fisdblind="+sqlTrue)
	if(snap && snap[0]>0)
	{
		isDblInd = true;
		snap = getSnap("select count(ftabn_id) from "+zppnm6+"  where Ftt=0 group by Fld8,Fld16 having count(ftabn_id)>1");
		if(snap && snap[0]>1)
			dblColor = 17;
		else
			dblColor = 2;
	}
}

function listSrc()
{
	this.qrySet("From", zppnm6, "Order", getOrder(sortMode));
}

function listDpGrid()
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	with( oGrid )
	{
		defCond("=^Ftt==1", "ITOG_ALL");
		color(1, "ITOG_ALL");
		bold("ITOG_ALL");
		defCond("=^Fisdblind==true", "DBL_IND");
		color(dblColor, "DBL_IND");
	}
	
	gr.FieldEx("=(^Ftt==0)?^Ftabnn:'Итого'","Таб.№|Таб.№",6,"","%10d");	
	gr.FieldEx("=(^Ftt==1)?'':getSmallFIO(^Fld12)","ПIБ|ФИО",15);	
	gr.FieldEx("Fld8","Iдент-й №|Идент-й №",12,"e");
	gr.FieldEx("FGRUKR","Гр.\nУкр.|Гр.\nУкр.", 3, "e");
	gr.FieldEx("FLD7","Стать|Пол", 3, "e");	
	if(isDblInd)
		gr.FieldEx("Fisdblind","Задв.\nід.№|Задв.\nид.№",3);
	with(gr.group("Сума|Сумма"))
	{
		FieldEx("FLD13","доходу|дохода",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("FLD14","дох.с огр.|дох.з гран.",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("FLD15","податку|налога",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	}
	//gr.FieldEx("FLD6","Тип ст.\nстр.вн.|Тип ст.\nстр.взн.", 3, "e");
	gr.FieldEx("FLD9","Кат.\nЗО|Кат.\nЗЛ", 3, "e");
	gr.FieldEx("FLD10","Тип\nнар.|Тип\nнач.", 3, "e");
	gr.FieldEx("FMES","Мiс.\nнар.|Мес.\nнач.", 8, "e");	
	gr.FieldEx("FLD16","Тр.\nкн.|Тр.\nкн.",3,"e");
	gr.FieldEx("FLD17","с/стаж|с/стаж",3,"e");
	gr.FieldEx("FKLDNB","К.дн/б.|К.дн./б.",5,"e");
	gr.FieldEx("FKLDNO","К.дн/о.|К.дн./о.",5,"e");
	gr.FieldEx("FKLDNR","К.дн/р.|К.дн./р.",5,"e");
	gr.FieldEx("FNEWRM","Нов.р.м.|Нов.р.м.",5,"e");	
	oGrid.build();
}

function listMenuInit()
{
	with(this.dataSrc)
    {
		if (!list.tbl.IsEmpty())
		{
			AddMenuItem("MININD", "Згорнути по ідентифікаційному номеру|Свернуть по идентификационному номеру");
			AddMenuItem ("","");
			switch(sortMode)
			{
				case "FIO":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО",ICON_RADIO);
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
				case "IND":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№",ICON_RADIO);
				break;
				case "TABN":
				default:
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№",ICON_RADIO);
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
			}
			AddMenuItem("","");
			AddMenuItem("ADD", ru("Добавить", "Додати"));
			AddMenuItem("EDIT","Редагувати|Редактировать");
			AddMenuItem("PSOG", "Проставить сумму ограничения = сумме дохода");
			AddMenuItem("RIT","Перерахувати пiдсумки|Пересчитать итоги");						
			AddMenuItem("DBF_EXP",ru("Экспорт данных персонификации", "Експорт даних персоніфікації"));
			//AddMenuItem("CHECKSUM","Перевірити суми по 6 таблицi|Проверить суммы по 6 таблице");
			AddMenuItem("PERITM","Перерахувати кiнцевi результати персон.|Перерасчитать окончат.расчеты персониф.");
			AddMenuItem("SVERRZ","Звiряння баз та ЄСВ в ОР та персон.|Сверка баз и ЕСВ в ЛС и персон.");
		}
	}
}


function listMenuRun(ID)
{
	switch(ID)
	{
		case "ADD":
			var form = createForm(ru("Введите табельный номер ","Введіть табельний номер "));
			pers = form.addCodPers(false,true);
			form.show();
			if(form.escape)
				return false;
			tabn = pers.getCod();
			tabn_id = pers.getFWID();
			t = OpenTable("Select * from ^listcl3 where Fwid_cl="+tabn_id);
	   		var m = new Object()
			m.Fld6   = 1
			m.Fld7   = ""			
			m.Fld8 = toScrObj(t.getValue("FINDNUM"))				
			m.Fld9   = 0
			m.Fld10  = 0
			m.Fld11  = d00obj;
			m.Fld13  = 0
			m.Fld14  = 0
			m.Fld15  = 0
			m.Fld16  = 0
			m.Fld17  = 0			
			m.Ftabn_id = tabn_id
			m.Ftabnn= tabn
			m.Ftt = 0
			m.Fld12  = toScrObj(t.getValue("FTXT"))
			m.Fkldnb = 0
			m.Fkldno = 0
			m.Fkldnr = 0
			m.Fnewrm = 0			
			
			var tmpName = (toScrObj(t.getValue("FTXT"))).replace("/\./g", ". ");
			var aWords = tmpName.split(" ");
       		var pfam = aWords[0]
       		var pnam = aWords[1]
       		var potch= aWords[2]
       		if (toScrObj(t.getValue("FISOTCH"))==true){
           		var pnam = aWords[1]+" "+aWords[2]
           		var potch= ""
       		}
			m.Fld12f  = toScrObj(pfam)
			m.Fld12i  = toScrObj(pnam)
			m.Fld12o  = toScrObj(potch)
			
			UpdateTable(zppnm6, m, true)
			t.close();
			list.tbl.requery();
			grid.RefreshGrid();
		break;
        case "RIT":
	  		DropTable("ZPPNS63")
	  		ExecuteSQL("delete from "+zppnm6+" where Ftt=1");
	  		ExecuteSQL("select sum(a.Fld13) as Fld13, sum(a.Fld14) as Fld14,sum(a.Fld15) as Fld15,sum(a.Fkldnb) as Fkldnb,sum(a.Fkldno) as Fkldno,sum(a.Fkldnr) as Fkldnr, 1 as Ftt"
	          	+" into ZPPNS63 from "+zppnm6+" as a where Ftt<>1")
	  		ExecuteSQL("insert into "+zppnm6+" (Fld13,Fld14,Fld15,Ftt,Fkldnb,Fkldno,Fkldnr) select Fld13,Fld14,Fld15, Ftt,Fkldnb,Fkldno,Fkldnr  from ZPPNS63");	          	
			list.tbl.requery();
			grid.RefreshGrid();
	        break;
		case "MININD":
			var msg = ru("Данная операция предназначена для сворачивания сумм совместителей заведенных на разные табельные номера " +
					"(удобнее заводить совместителей на тотже табельный номер).\n" +
					"Суммы сворачиваются по идентификационному номеру к минимальному табельному номеру, " +
					"обратно развернуть суммы уже будет невозможно (только расчитав заново).\nПродолжить?",
					"Дана операція призначена для згортання сум сумісників заведених на різні табельні номери " +
					"(зручніше заводити сумісників на той самий табельний номер).\n" +
					"Суми згортаються за ідентифікаційним номером до мінімального табельного номеру, " +
					"назад розгорнути суми вже буде неможливо (тільки розрахував знову).\nПродовжити?");
			if(!confirm(msg))
				break;
			DropTable("dblind_min_tabn");
			//отбираем номера с максимальным табельным номером
			var ok = ExecuteSQL("select Ftabn_id into dblind_min_tabn from "+zppnm6+" as z1 where Fisdblind="+sqlTrue+" and Ftt=0 "
						+" and Ftabn_id=(select MAX(Ftabn_id) from "+zppnm6+" as z2 where z1.Fld8=z2.Fld8)");
			DropTable("tbl_sum");
			//переделал сворачивание сумм по идент.номеру
			var tblName = "ZPPNS6_TMP";
			CreateTable(tblName, "ZPPNM613", "*");
			var fld = GetPatternIntersection("ZPPNM613", "ZPPNM613").replace(/(fwid\s*,)|(,\s*fwid)/gi,"").replace(/(ftabnn\s*,)|(,\s*ftabnn)/gi,"");
			var fldSel = GetPatternIntersection("ZPPNM613", "ZPPNM613").replace(/(fwid\s*,)|(,\s*fwid)/gi,"").replace(/(ftabnn\s*,)|(,\s*ftabnn)/gi,"").replace(/(fld13)/gi,"sum(fld13)").replace(/(fld14)/gi,"sum(fld14)").replace(/(fld15)/gi,"sum(fld15)").replace(/(fkldnb)/gi,"sum(fkldnb)").replace(/(fkldno)/gi,"sum(fkldno)").replace(/(fkldnr)/gi,"max(fkldnr)").replace(/(ftabn_id)/gi,"min(ftabn_id)");
			ExecuteSQL("insert into "+tblName+" ("+fld+") select "+fldSel+" from "+zppnm6+" group by ftt,fld6,fld7,fld8,fld9,fld10,fld11,fld12,fld12f,fld12i,fld12o,fld16,fld17,fisdblind,fgrukr,ftypr,fdatr,fdatf,fmes,fnewrm");
			ExecuteSQL("delete from "+zppnm6);
			ExecuteSQL("insert into "+zppnm6+" ("+fld+") select "+fld+" from "+tblName);
			ExecuteSQL("update "+zppnm6+" set ftabnn = (select MAX(Fcod) from ^clrelclcl as r where "+zppnm6+".ftabn_id=r.fwid_cl)");
/*			//сумируем
			if(ok)
				ok = ExecuteSQL("update "+zppnm6+" "
					+" set Fld13=(select SUM(Fld13) from "+zppnm6+" as z2 where "+zppnm6+".Fld8=z2.Fld8 and "+zppnm6+".Ftt=z2.Ftt and "+zppnm6+".Fld9=z2.Fld9 and "+zppnm6+".Fld10=z2.Fld10 and "+zppnm6+".Fmes=z2.Fmes), "
						+" Fld14=(select SUM(Fld14) from "+zppnm6+" as z2 where "+zppnm6+".Fld8=z2.Fld8 and "+zppnm6+".Ftt=z2.Ftt and "+zppnm6+".Fld9=z2.Fld9 and "+zppnm6+".Fld10=z2.Fld10 and "+zppnm6+".Fmes=z2.Fmes), "
						+" Fld15=(select SUM(Fld15) from "+zppnm6+" as z2 where "+zppnm6+".Fld8=z2.Fld8 and "+zppnm6+".Ftt=z2.Ftt and "+zppnm6+".Fld9=z2.Fld9 and "+zppnm6+".Fld10=z2.Fld10 and "+zppnm6+".Fmes=z2.Fmes), "
						+" Fkldnb=(select SUM(Fkldnb) from "+zppnm6+" as z2 where "+zppnm6+".Fld8=z2.Fld8 and "+zppnm6+".Ftt=z2.Ftt and "+zppnm6+".Fld9=z2.Fld9 and "+zppnm6+".Fld10=z2.Fld10 and "+zppnm6+".Fmes=z2.Fmes), "
						+" Fkldno=(select SUM(Fkldno) from "+zppnm6+" as z2 where "+zppnm6+".Fld8=z2.Fld8 and "+zppnm6+".Ftt=z2.Ftt and "+zppnm6+".Fld9=z2.Fld9 and "+zppnm6+".Fld10=z2.Fld10 and "+zppnm6+".Fmes=z2.Fmes) "						
					+" where Fisdblind="+sqlTrue+" and not exists(select Ftabn_id from dblind_min_tabn as d where "+zppnm6+".Ftabn_id=d.Ftabn_id)");
			//удаляем номера с максимальным номером
			if(ok)
				ok = ExecuteSQL("delete from "+zppnm6+" where Fisdblind="+sqlTrue+" and Ftabn_id in (select Ftabn_id from dblind_min_tabn)");
*/
			if(ok)
			{
				dblColor = 2;
				list.tbl.requery();
				grid.DeletePages();
				list.init();
			}
		break;
		case "SORTTABN":
		case "SORTFIO":
		case "SORTIND":
			sortMode = ID.replace("SORT","");
			grid.DeletePages();
			list.init();
		break;
	    case "PSOG":
		  ExecuteSQL("update "+zppnm6+" set Fld14=Fld13 where "+DataSource().sqlSelected());
		  list.tbl.requery();
		  grid.RefreshGrid();
          break;
		case "DBF_EXP":
			var sFileName = BrowseForFile("*.dbf",ru("Экспорт в dbf файл 6-й таблицы","Експорт в dbf файл 6-у таблицю"),null,"save","E04T06F.dbf")
			if (sFileName)
				expToDbfMonthPers(zppnm6, sFileName, null, gd.dat1);
		break;
		case "CHECKSUM":
			var t6 = OpenTable("select Ftabn_id, Ftabnn, sum(Fld14) as Fsum, sum(Fld15) as Fnal from "+zppnm6+" where Ftt=0 group by Ftabn_id, Ftabnn order by Ftabnn");
			var m = new Object();
			m.Fwid = "COUNTER";
			m.Ftabnn = "LONG";
			m.Fsum = "MONEY";
			m.Fnal1 = "MONEY";
			m.Fnal2 = "MONEY";
			m.Fsumd = "MONEY";
			CreateTable("check_pers", m);
			
			var proc = get_cnst("proc_pns",gd.dat1);
			setProgressRange(1, t6.rowCount);
			for(; !t6.IsEOF(); t6.MoveNext())
			{
				setProgressPos(t6.bookmark, t6.bookmark+"/"+t6.rowCount);
				var Fsum = Number(t6.getValue("Fsum"));
				var Fnal = Number(t6.getValue("Fnal"));
				//проверяем если расхождение больше 2 копеек
				if(Math.abs(round(Fsum*proc/100,2)-round(Fnal,2))>0.02)
				{
					var m = new Object();
					m.Ftabnn = t6.getValue("Ftabnn");
					m.Fsum = Fsum;
					m.Fnal1 = round(Fsum*proc/100,2);
					m.Fnal2 = round(Fnal,2);
					m.Fsumd = round((m.Fnal2-m.Fnal1)*100/proc,2);
					UpdateTable("check_pers", m, true);
				}
			}
			setProgressPos(0);
			var par = new Object();
			par.cells = new Object();
			par.caption = UR("Таб.№ з помилковими сумами|Таб.№ с ошибочными суммами");
		
			par.cells[1] = new Object();
			par.cells[1].name = "Ftabnn";
			par.cells[1].width = 6;
			par.cells[1].text = UR("Таб.№|Таб.№");
		
			par.cells[2] = new Object();
			par.cells[2].name = "Fsum";
			par.cells[2].width = 10;
			par.cells[2].text = UR("База");	
			
			par.cells[3] = new Object();
			par.cells[3].name = "Fnal2";
			par.cells[3].width = 10;
			par.cells[3].text = UR("Утримано в ЕВ|Удержано в ЕВ");
			
			par.cells[4] = new Object();
			par.cells[4].name = "Fnal1";
			par.cells[4].width = 10;
			par.cells[4].text = UR("Утримано в ЕВ (перевірка)|Удержано в ЕВ (проверка)");
			
			par.cells[5] = new Object();
			par.cells[5].name = "Fsumd";
			par.cells[5].width = 10;
			par.cells[5].text = UR("Різниця бази ЕВ\n(приблизно)|Разница базы ЕВ\n(приблизительно)");
			var tbl = OpenTable("select * from check_pers order by Ftabnn");
			if(tbl.rowCount>0)
				browse(tbl, par, SW_MODAL);
			else
				alert(ru("Помилок не знайдено.","Ошибок не найдено."))
			tbl.close();
			t6.close();
		break;
    case "PERITM":
	gd = new DpGetDat("d");
	if(gd.escape)
		return false;
	szTag = getDateTag(gd.dat1);
	zppnm6 = "^ZPPFMVI"+szTag;
	    
    //переделал на постоянные таблицы, чтоб одни и те же пользователи работающие с несколькими базами не затирали результаты предыдущей расчитанной базы
    //CreateTableEx("ZRP_RES","ZRP_ZPPNMVI"+szTag, "ZPPNM6", "*");
    //var zppnm6 = "^ZPPNMVI"+szTag;
    ExecuteSQL("delete from "+zppnm6)
    strSQL = "insert into "+zppnm6+"(Fisdblind,Ftabn_id,Ftabnn,Fld6,Fld7,Fld8,Fld9,Fld10,Fld11,Ftt,Fld12,Fld12f,Fld12i,Fld12o,Fld13,Fld14,Fld15,Fld16,Fld17,Fkldnb,Fkldno,Fkldnr,Fnewrm,Fmes)"
    		+" select Fisdblind,Ftabn_id,Ftabnn,Fld6, Fld7,Fld8, Fld9, Fld10, Fld11, 0 as Ftt, Fld12, Fld12f, Fld12i, Fld12o,sum(Fld13) as Fld13, sum(Fld14) as Fld14,sum(Fld15) as Fld15,"
            	+" Fld16,Fld17,sum(Fkldnb) as Fkldnb,sum(Fkldno) as Fkldno,sum(Fkldnr) as Fkldnr, Fnewrm, Fmes "
            +" from ZPPNS61 "
            +" group by Ftabn_id,Ftabnn,Fld6,Fld7,Fld8,Fld12,Fld12f,Fld12i,Fld12o,Fld9,Fld10,Fld11,Fld16,Fld17,Fmes,Fnewrm,Fisdblind"
    ExecuteSQL(strSQL);
    
    DropTable("ZPPNS62")
    ExecuteSQL("select sum(Fld13) as Fld13, sum(Fld14) as Fld14,sum(Fld15) as Fld15, 1 as Ftt,sum(Fkldnb) as Fkldnb,sum(Fkldno) as Fkldno,sum(Fkldnr) as Fkldnr"
            +" into ZPPNS62 from "+zppnm6);
    ExecuteSQL("insert into "+zppnm6+" (Ftabn_id,Ftabnn,Ftt,Fld6,Fld7,Fld8,Fld9,Fld10,Fld11,Fld12,Fld12f,Fld12i,Fld12o,Fld13,Fld14,Fld15,Fld16,Fld17,Fkldnb,Fkldno,Fkldnr,Fnewrm,Fmes) select 0,0,Ftt,0,0,'',0,0,"+sqlTo(d00obj)+",'','','','',Fld13,Fld14,Fld15,0,0,Fkldnb,Fkldno,Fkldnr,0,"+sqlTo(d00obj)+" from ZPPNS62");    
		  list.tbl.requery();
		  grid.RefreshGrid();
          break;
    case "SVERRZ":
    	//include("scripts\l_svb11.js");
		var par = new Object();    
		showWindow("l_svb11.js", SW_NOMODAL, par);    	
		//list.tbl.requery();
		//grid.RefreshGrid();
        break;
	}
}

function gridEdit(modeID)
{
	if(modeID=="ADD" || modeID=="COPY")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	if(list.tbl.getValue("Ftt")==0)
	{
		var n = new Object();
		n.Fld6  = list.tbl.getValue("Fld6");
		n.Fld7  = list.tbl.getValue("Fld7");
		n.Fld9  = list.tbl.getValue("Fld9");
		n.Fld8  = list.tbl.getValue("Fld8");
		n.Fld10  = list.tbl.getValue("Fld10");
		n.Fld11  = list.tbl.getValue("Fld11");		
		n.Fld13 = list.tbl.getValue("Fld13");
		n.Fld14 = list.tbl.getValue("Fld14");
		n.Fld15 = list.tbl.getValue("Fld15");			
		n.Fld16  = list.tbl.getValue("Fld16");
		n.Fld17  = list.tbl.getValue("Fld17");
		n.Fkldnb  = list.tbl.getValue("Fkldnb");
		n.Fkldno  = list.tbl.getValue("Fkldno");
		n.Fkldnr  = list.tbl.getValue("Fkldnr");
		n.Fnewrm  = list.tbl.getValue("Fnewrm");		
		UpdateTable(zppnm6, n, false, "Fwid="+list.tbl.getValue("Fwid"));
								
		//апдейтим общий итог
		var snap = getSnap("select SUM(Fld13),SUM(Fld14),SUM(Fld15),SUM(Fkldnb),SUM(Fkldno),SUM(Fkldnr)"
						+" from "+zppnm6+""
						+" where Ftt<>1");
		if(snap)
		{
				m.Fld13 = snap[0];
				m.Fld14 = snap[1];
				m.Fld15 = snap[2];
				m.Fkldnb = snap[3];
				m.Fkldno = snap[4];
				m.Fkldnr = snap[5];				
				UpdateTable(zppnm6, m, false, "Ftt=1");
		}

	}
	return true;
}

function listDel()
{

	ExecuteSQL("delete from "+zppnm6+" where Fwid="+list.tbl.getValue("Fwid"));
	//апдейтим общий итог
	var snap = getSnap("select SUM(Fld13),SUM(Fld14),SUM(Fld15),SUM(FKLDNB),SUM(FKLDNO),SUM(FKLDNR) "
				+" from "+zppnm6+" where Ftt=0");
	var m = new Object();				
	if(snap)
	{
		m.Fld13 = snap[0];
		m.Fld14 = snap[1];
		m.Fld15 = snap[2];
		m.Fkldnb = snap[3];
		m.Fkldno = snap[4];
		m.Fkldnr = snap[5];		
		UpdateTable(zppnm6, m, false, "Ftt=1");
	}
	return false;
}

function getTblH()
{ 
	var h = new Object();
	h.HDAT1 = gd.dat1;
	return h;
}

function getOrder(mode)
{
	var sOrder = "Ftt,Ftabnn";
	switch(String(mode))
	{
		case "FIO":
			sOrder = "Ftt,Fld12, Ftabnn";
		break;
		case "IND":
			sOrder = "Ftt,Fld8, Ftabnn";
		break;
	}
	return sOrder;
}
include("sys/DpList.js");	
	