//просмотр справки в пенсионный фонд помесячной
include("gridedit.js");
include("Objects/DpGetDat.js");
include("servis/format.js");
include("r_compt5.js");
include("servis/date.js");
include("sys/udfs.js");
include("servis/zrp.js");
var sortMode = "FTABNN";
var Ftabn = 0;
var gd, szTag, zppnm5, menuMode;

function listLoad()
{
	gd = new DpGetDat("d");
	if(gd.escape)
		return false;
	szTag = getDateTag(gd.dat1);
	zppnm5 = "^ZPPNMV"+szTag;
	menuMode = GetMenuMode().toUpperCase();
	
	if(menuMode.indexOf("CALC")==-1)
	{
		if (!IsTableEx("ZRP_RES","ZRP_ZPPNMV"+szTag))
		{
			alert(ru("Cначала сделайте расчет таблицы 5 за ",	"Спочатку виконайте розрахунок таблиці 5 за ")+format("Mmm yyyy",gd.dat1).toLowerCase());
			return false;
		}
		else
			this.title = UR("Перегляд таблиці 5 - |Просмотр таблицы 5 - ")+format("Mmm yyyy",gd.dat1).toLowerCase();
	}
	else
	{
		var msg = ru("Таблица 5 уже расчитана за ",
				"Таблиця 5 вже розрахована за ")+format("Mmm yyyy",gd.dat1).toLowerCase()+"\n"+ru("Продолжить расчет?","Продовжити розрахунок?");
		if (IsTableEx("ZRP_RES","ZRP_ZPPNMV"+szTag) && !confirm(msg))
		{
			return false;
		}
		var par=new Object();
//		par.sysname = getSysName();
//		par.escape = false;
		par.xyear = gd.dat1;		
//	    par.typ1 = true;
//	   par.typ2 = false;
//	    par.typ3 = false;
//	    par.sdatr = today.getVarDate();
//		par._KPFU = "";
//		par._KTSZ = "0";
//	    
//		showWindow("e_zsprpt5.xml", SW_MODAL, par);	
//		setParWithDef("DAT1_P", par.xyear, par.sysname);
//		if (par.escape)
//			return false;
		this.title = UR("Розрахунок таблиці 5 - |Расчет таблицы 5 - ")+format("Mmm yyyy",gd.dat1).toLowerCase();
	
		r_compt5 (par);
	}
	
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
}

function listSrc()
{
	this.qrySet("From", zppnm5, "Order", getOrder(sortMode));
}

function listDpGrid()
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	gr.FieldEx("Ftabnn","Таб.№|Таб.№",6,"","%10d");
	gr.FieldEx("Fld6","Iдент-й №|Идент-й №",12);		
	gr.FieldEx("=getSmallFIO(^Fld7)","ПIБ|ФИО",25);
	gr.FieldEx("FGRUKR","Гр.\nУкр.|Гр.\nУкр.", 3, "e");	
	gr.FieldEx("Fbdat","дата поч.|дата нач.", 15, "e");
	gr.FieldEx("Fedat","дата кiнця|дата конца", 15, "e");
	with(gr.group("Категорія осіб|Категория лиц"))
	{
		FieldEx("FKATOSOB","Код|Код", 4, "e");
		FieldEx("=getTxtKatPersTbl5(^FKATOSOB)","Назва|Название", 25);
	}
	gr.FieldEx("Fprichuv","Причина звільнення|Причина увольнения", 20, "e");
	gr.FieldEx("Fdatnewrm","дата нов.р.м.|дата нов.р.м.", 15, "e");	
	oGrid.build();
}

function listMenuInit()
{
	with(this.dataSrc)
    {
		if (!list.tbl.IsEmpty())
		{
			AddMenuItem ("","");
			switch(sortMode)
			{
				case "FIO":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО",ICON_RADIO);
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
				case "IND":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№",ICON_RADIO);
				break;
				case "TABN":
				default:
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№",ICON_RADIO);
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
			}
			AddMenuItem("","");
			AddMenuItem("ADD", ru("Добавить", "Додати"));
			AddMenuItem("EDIT","Редагувати|Редактировать");
			AddMenuItem("RIT","Перерахувати пiдсумки|Пересчитать итоги");
			AddMenuItem("DBF_EXP",ru("Экспорт данных персонификации", "Експорт даних персоніфікації"));
		}
	}	
}


function listMenuRun(ID)
{
	switch(ID)
	{
		case "ADD":
			var form = createForm(ru("Введите табельный номер ","Введіть табельний номер "));
			pers = form.addCodPers(false,true);
			form.show();
			if(form.escape)
				return false;
			tabn = pers.getCod();
			tabn_id = pers.getFWID();
			t = OpenTable("Select * from ^listcl3 where Fwid_cl="+tabn_id);
	   		var m = new Object()
			m.Fbdat  = d00obj.getVarDate();
			m.Fedat  = d00obj.getVarDate();			
			m.Ftabn = tabn_id
			m.Ftabnn= tabn			
			m.Fld7  = toScrObj(t.getValue("FTXT"))
			
			var tmpName = m.Fld7.replace("/\./g", ". ");			
			var aWords = tmpName.split(" ");
       		var pfam = aWords[0]
       		var pnam = aWords[1]
       		var potch= aWords[2]
       		if (toScrObj(t.getValue("FISOTCH"))==true){
           		var pnam = aWords[1]+" "+aWords[2]
           		var potch= ""
       		}
			
			m.Fld6 = toScrObj(t.getValue("FINDNUM"))
			m.Fld7f  = toScrObj(pfam)
			m.Fld7i  = toScrObj(pnam)
			m.Fld7o  = toScrObj(potch)
										
			UpdateTable(zppnm5, m, true)
			t.close();
			list.tbl.requery();
			grid.RefreshGrid();
		break;
		case "SORTTABN":
		case "SORTFIO":
		case "SORTIND":
			sortMode = ID.replace("SORT","");
			grid.DeletePages();
			list.init();
		break;
		case "DBF_EXP":
			var mode = menuMode.replace(/calc|view/gi,'');
			var sFileName = BrowseForFile("*.dbf",ru("Экспорт в dbf файл 5-й таблицы","Експорт в dbf файл 5-у таблицю"),null,"save",mode==2011?"E04T05D.dbf":"E04T05F.dbf");
			if(sFileName)
				expToDbfMonthPers(zppnm5, sFileName, null, gd.dat1, mode);
		break;
	}
}

function gridEdit(modeID)
{
	if(modeID=="ADD" || modeID=="COPY")
		return false;
	return true;
}

function saveRecord()
{
	var n = new Object();
	n.Fbdat = list.tbl.getValue("Fbdat");
	n.Fedat = list.tbl.getValue("Fedat");		
	UpdateTable(zppnm5, n, false, "Fwid="+list.tbl.getValue("Fwid"));
	return true;
}

function listDel()
{
	ExecuteSQL("delete from "+zppnm5+" where Fwid="+list.tbl.getValue("Fwid"));
	return false;
}

function getTblH()
{ 
	var h = new Object();
	h.HDAT1 = gd.dat1;
	return h;
}

function getOrder(mode)
{
	var sOrder = "Ftabnn, Fbdat";
	switch(String(mode))
	{
		case "FIO":
			sOrder = "Fld7, Ftabnn, Fbdat";
		break;
		case "IND":
			sOrder = "Fld6, Ftabnn, Fbdat";
		break;
	}
	return sOrder;
}
include("sys/DpList.js");	
	