//13.11.12 Яна соединила правки в БЦ с последними правками в CVS 
include("doc/DpDoc.js");
include("sys/dbase.js");
include("gridedit.js");
include("sys/udfs.js");
include("servis/format.js");
include("servis/zrp.js");
include("servis/date.js");
include("Objects/DpExtentionBuilder.js");
include("Objects/DpClEx.js");

var bdat = edat = null;
var onlyOrg = true;
var currentID = "0";
var treeTbl = "^stru_org";
var gridXml = getPar("TABNORG")?"l_shtatTabnOrg.xml":"l_shtatRas.xml";
var workTable = "";
var table = null;
var codPers;

var isZaval = false;
var isMass = false;
var arraySelectedIDs = new Array();
var useStructMenu = true;
var usePersonalMenu = true;
var dpGridEdit = null;

//extSstTblName - таблица в которой хранятся расширения к справочнику оснований для учета стажа отдельным категориям лиц (для новой персонификации)
//к справочнику нужно создать следующие расширения: CODOSN (тип текст 8 символов), BDAT и EDAT (тип дата)
var extSstTblName;

// флаг для отмены загрузки главной ветки
var onStartLoad = true;

function listLoad()
{
	this.title = (UR("Штатний розклад підприємства|Штатное расписание предприятия"));
	this.printLabel = "SHTAT";
	
	var existsDat = false;
	if (typeof extPar != "undefined" && (typeof extPar.ret == "object" || extPar.isZaval))
	{
		isZaval = true;
		useStructMenu = false;
		usePersonalMenu = false;
		if (extPar.dat1 && extPar.dat2)
		{
			existsDat = true;
			bdat = extPar.dat1;
			edat = extPar.dat2;
		}
		if (extPar.isZaval && extPar.isMass)
		{
			isMass = extPar.isMass;
			//arraySelectedIDs = new Array();
			this.save = onSave;
			this.escape = onEscape;			
		}
	}
	if (!existsDat)
	{	 
		include("objects/DpGetDat.js");
		var gd = new DpGetDat("dD");
		if (gd.escape == true)
			return false;
		bdat = gd.dat1;
		edat = gd.dat2;
	}
	
	//удаляем ошибочные записи
	ExecuteSQL("delete from ^stru_dol where fwid in (select fwid_dol from ^work_pers where fbdat is null or fbdat="+sqlTo(d00)+")")
	ExecuteSQL("delete from ^work_pers where fbdat is null or fbdat="+sqlTo(d00))
	
	this.title = (UR("Штатний розпис підприємства з |Штатное расписание предприятия с ")
		 + StrDat(bdat, "DMY") + UR(" до | по ") + StrDat(edat, "DMY"));
	
	if (!isZaval)	
	{
		if (!isAccessOnRun())
			return false;
	}
	
	this.checkHandler = checkHandler;
	grid.addCheckHandler(this, "checkHandler");
		
	this.onTreeSelectMenuHandler = onTreeSelectMenuHandler;
	Tree.selectMenuHandler(this, "onTreeSelectMenuHandler");
	this.onTreeMenuInit = onTreeMenuInit;
	Tree.loadMenuHandler(this, "onTreeMenuInit");	
	
	this.onTreeSel = onTreeSelected;		
	this.showTreeByDefault = true;
	this.hideTreeMenuItem = true;
	this.initTree(Tree, "=getLvls(^flv1,^flv2,^flv3,^flv4,^flv5) + ' : ' +^ftxt" , treeTbl);
	
	//workTable = getTmpTableName();
	workTable = "TMP_WORK_TABLE";
	//this.xmlGridFile = gridXml;
	grid.setXMLFile(gridXml);
	//редактируемый грид пока не работает коректно, атрибут attr="e" пока закоментирован  
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
	dpGridEdit.addValidField("FOKLAD", null, oklad_valid);
	if(getPar("ZRP_SST"))
	{
		var oExt = new DpExtentionBuilder("CL",String(getPar("ZRP_SST")));
		msg = ru("Для коректного расчета свода помесяной персонификации необходимо\nв "+getPar("ZRP_SST")+" справочнике аналитики создать следующие расширения:\nCODOSN (тип текст 8 символов), BDAT и EDAT (тип дата)",
					"Для коректного розрахунку свода помісячної персоніфікації потрібно\nв "+getPar("ZRP_SST")+" довіднику аналітики створити наступні розширення:\nCODOSN (типу текст 8 символів), BDAT та EDAT (типу дата)")
		if(oExt.exist())
		{
			extSstTblName = oExt.getValueTableName();
			var baseFields = new Array("FCODOSN", "FBDAT", "FEDAT");
			var tbl = OpenTable("select * from "+extSstTblName);
			var listSrcFields = tbl.getFieldsInfo();
			tbl.close();
			var srcFields = new Array();
			for(var i = 0; i < listSrcFields.length; i++)
			{
				srcFields[i] = String(listSrcFields[i].getName()).toUpperCase();
			}
			var baseLng = baseFields.length;
			var notExistsFields = new Array();
			for(var i = 0; i < baseLng; i++)
			{
				if(!srcFields.some( function(item){ return item==baseFields[i]} ))
					notExistsFields[notExistsFields.length] = baseFields[i];
			}
			if(notExistsFields.length>0)
			{
				var str = new java.lang.String(notExistsFields+"");
				//т.к. в названии расширений символ "F" отсутсвует, то смело его вырезаем из названия полей, чтобы получить имя расширения
				str = str.replaceAll("F", "");
				alert(ru("В "+getPar("ZRP_SST")+" справочнике аналитики отсутствуют следующие расширения:\n"+str+"\n",
						"В "+getPar("ZRP_SST")+" довіднику аналітики відсутні наступні розширення:\n"+str+"\n")+msg);
			}
		}
		else
			alert(msg);
	}
	if(typeof const_GETPAR_PERSONAL != "undefined" && !getPar(const_GETPAR_PERSONAL))
		alert("Не установлен в параметрах код справочника сотрудников!","Не встановлено в параметрах код довідника співробітників!",ICON_WARNING)+"\n"+getParItemPath(const_GETPAR_PERSONAL, true);
	else
	{
		if(!getPar("CODPERS"))
			alert("Не установлен в параметрах код справочника сотрудников!","Не встановлено в параметрах код довідника співробітників!",ICON_WARNING)+"\n"+getParItemPath("CODPERS", true);
	}
}

function getTblH()
{
	var h = new Object();
	h.HDAT1 = bdat;
	h.HDAT2 = edat;
	return h;
}

function gridEdit(sMode)
{
	mode = sMode;
	if (mode == "EDIT")
		return true;
	else
		return false;
}

function saveRecord()
{
	//ExecuteSQL("UPDATE ^stru_dol SET Foklad="+sqlTo(list.tbl.getValue("Foklad"))+" WHERE Fwid="+sqlTo(list.tbl.getValue("Fwid_dol")))
	//alert(grid.getTable().getValue("Foklad"))
	return true;
}

function oklad_valid(oCtrl)
{
	if(oCtrl.getValue()<0)
	{
		alert(ru("Оклад не может быть отрицательным!","Оклад не може бути від'ємним!"));
		return false;
	}
	return true;
}

function listAfterLoad()
{
	if (Tree.getItemCount() <= 0)
	{
		alert(UR("Не знайдено жодного запису на заданий період!|Не найдено ни одной записи за выбраный период!"),
				ICON_WARNING);
		CloseWindow();
		return false;
	}
	var childs = Tree.getChildsOf("0");
	if (childs != null && childs.length > 0 && onStartLoad)
	{
		Tree.setSelected(childs[0]);
		onTreeSelected(childs[0]);
	}
	refreshTree();
}

function listDelAcc()
{
	return false;
}

function listSrc()
{
	this.qrySet("Fields", "n.*",
				"From", treeTbl + " AS n",
				"Where", "fwid<>0 AND fbdat<=" + sqlTo(edat) + " AND fedat>=" + sqlTo(bdat),
				"Order", "fleftkey");
	this.subTie("^cl", "EXT_SST", "Fwid", "Fwid_cl");
}

function getTreeParentField()
{
	return "fwid_par";
}

function onTreeSelected(treeID, gridID)
{
	if (currentID == treeID)
		return;
	currentID = treeID;
	fillGrid(gridID, 1);
}

function fillGrid(gridID, selection)
{			
	if (requaryTable())
		showGrid(gridID, selection);
	else
		grid.getGridControl().setVisible(false);
}

var useFast = false;
var snapOrg = getSnap("SELECT fleftkey, frightkey FROM ^stru_org WHERE fwid_par=0");
var alredyFillTbl = false;
var sqlID = null;
var sqlLeftKey = null;
var sqlRightKey = null;

function requaryTable()
{
	sID = currentID;
	sqlID = sqlTo(Number(sID));
	if (Number(sID) == 0)
		return false;
	var item = Tree.getItem(sID);
	if (item == null)
		return false;
	if (useFast && (alredyFillTbl == false && (snapOrg != null && (snapOrg[0] != null || snapOrg[1] != null))))
	{
		sqlLeftKey = snapOrg[0];
		sqlRightKey	= snapOrg[1];
		alredyFillTbl = true;	
	}
	else
	{
		sqlLeftKey = sqlTo(Number(item.getData("fleftkey")));
		sqlRightKey = sqlTo(Number(item.getData("frightkey")));	
	}
	
	if (useFast && alredyFillTbl && IsTable(workTable))
		return true;	
		
	if (table != null)
		table.close();
	if(IsTable(workTable))
		DropTable(workTable);
	createTmpTable(workTable);
	//browse(workTable);
	var isFwid_cl = false;
	if(typeof extPar != "undefined" && extPar.wid_cl!=null)
		isFwid_cl = true;
	
	//сперва заносим подразделения
	ExecuteSQL("INSERT INTO " + workTable
				+ " (fwid, ftabn_id, fwid_dol, fbdat, fedat, fvopl, ftxt, fcod, fpos, fident, fleftkey, frightkey, fkolst, foklad, fcoddol, "
				+ " finval, fshpz, fid, favans, fkodkat, fkodzvan, fis_serv, fis_uv, fis_nazn, fnewrm, FTABLE, Fcalend, Fismain, Fpens, fpodr) "
				+ " SELECT fwid, 0 AS ftabn_id, 0 AS fwid_dol, fbdat, "
				+ " fedat, 0 AS fvopl, ftxt, 0 AS fcod, ' ' AS fpos,1 AS fident, fleftkey, frightkey, 0 as fkolst, 0 AS foklad, "
				+ " 0 AS fcoddol, 0 AS  finval," + sqlTo("0") + " AS fshpz, 0 AS fid, 0 AS favans, 0 AS fkodkat, 0 AS fkodzvan, "
				+ " 0 AS fis_serv, 0 AS fis_uv, 0 AS fis_nazn, 0 as fnewrm, 0 as FTABLE, 0 as Fcalend, 0 as Fismain, 0 as Fpens , fpodr"
				+ " FROM " + treeTbl
				//если завал по конкретному таб.номеру, то отбираем подразделения относящиеся только к этому номеру
				+ (isFwid_cl?" WHERE fwid IN (SELECT fwid_org FROM ^stru_dol WHERE fwid IN "
								+"(SELECT fwid_dol FROM ^work_pers WHERE fwid_cl="+sqlTo(extPar.wid_cl)+"))"
							:" WHERE fwid=" + sqlID
				+ " OR (fleftkey BETWEEN " + sqlLeftKey + " AND " + sqlRightKey + ") AND fwid<>0 "
				+ " AND fbdat<=" + sqlTo(edat) + " AND fedat>=" + sqlTo(bdat))
				);
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_PERSONAL != "undefined")
		codPers = getPar(const_GETPAR_PERSONAL);
	else
		codPers = getPar("CODPERS");
	var codDol = getPar("CODDOL","ZRP");
//	var codKat = (getSystem().equalsIgnoreCase("zrp") ? getPar("CODKAT") : getPar("CODKAT"));

	// Добавить в таблицу информацию о сотрудниках
	// Оштбка
	var addSQL = "";
	if(isFwid_cl)
		addSQL = " AND wp.Fwid_cl="+sqlTo(extPar.wid_cl);
		
	//пробывал переделать этот INSERT на view FULL_PERS, но на больших базах или слабых серверах появлялись проблемы
	ExecuteSQL("INSERT INTO " + workTable
				+ " (fwid, ftabn_id, fwid_dol, fbdat, fedat, fvopl, ftxt, fcod, fpos, fident, fleftkey, frightkey, fkolst, foklad, fcoddol, "
				+ " finval, fshpz, fid, favans, fkodkat, fkodzvan, fis_serv, fis_uv, fis_nazn, fnewrm, FTABLE, fcalend, Fkod_uv, Fismain, Fpens, Fcod_ssv, Fcod_kzo, Fcod_sst, Ftabnorg, Fsex, Fwrkdat, Fpodr,Findnum,FDOCSER,FDOCNOM,FDOCOWN,FDOCDAT,FPIDROZD,fwidOrg_I) "
				//+ " SELECT " + IIF("wp.fwid is null or wp.fwid = 0 ", "dol.fwid", "wp.fwid") + " AS fwid, wp.fwid_cl AS ftabn_id, dol.fwid AS fwid_dol, wp.fbdat AS fbdat, " 
				+ " SELECT wp.fwid AS fwid, wp.fwid_cl AS ftabn_id, dol.fwid AS fwid_dol, wp.fbdat AS fbdat, "
				+ " wp.fedat AS fedat, wp.fvopl AS fvopl, wp_cl.ftxt AS ftxt, "
				+ " crc.fcod AS fcod, dol_cl.ftxt AS fpos, 0 AS fident, org.fleftkey AS  fleftkey, org.frightkey AS frightkey, "
				+ " wp.fkolst, dol.foklad AS foklad, dol_crc.fcod AS fcoddol, wp.finval AS finval, dol.fshpz AS fshpz, "
				+ " wp.fid AS fid, wp.favans AS favans, kat_crc.fcod AS fkodkat, "+IIF("zvan_crc.fcod is null","0","zvan_crc.fcod")+" AS fkodzvan, wp.fis_serv AS fis_serv, "
				+ " wp.fis_uv AS fis_uv, wp.fis_nazn AS fis_nazn, wp.fnewrm AS fnewrm, wp.FTABLE as FTABLE, wp.Fcalend as Fcalend, wp.Fkod_uv as Fkod_uv, wp.Fismain, wp.Fpens as Fpens, wp.Fcod_ssv, wp.Fcod_kzo, wp.Fcod_sst, wp.Ftabnorg, h.Fsex, h.fwrkdat, 0 AS Fpodr,h.Findnum,h.FDOCSER,h.FDOCNOM,h.FDOCOWN,h.FDOCDAT,org.FTXT,org.FWID "
				+ " FROM (((^stru_dol dol "
						+ "	INNER JOIN ^stru_org AS org ON dol.fwid_org=org.fwid "	
					+ " INNER JOIN (((((^work_pers AS wp "
						+ " LEFT JOIN ^cl AS wp_cl ON wp_cl.fwid=wp.fwid_cl) "
						+ " LEFT JOIN ^cl_homo AS h ON h.fwid_cl=wp.fwid_cl) "
						+ " LEFT JOIN ^clrelclcl AS crc ON crc.fwid_cl=wp.fwid_cl) "
						+ " LEFT JOIN ^clrelclcl AS zvan_crc ON zvan_crc.fwid_cl=wp.fwid_zvan) "
						+ " LEFT JOIN ^clrelclcl AS kat_crc ON kat_crc.fwid_cl=wp.fwid_kat) ON wp.fwid_dol=dol.fwid) "
					+ " LEFT JOIN ^cl AS dol_cl ON dol_cl.fwid=dol.fwid_cl) "
					+ " LEFT JOIN ^clrelclcl AS dol_crc ON dol_crc.fwid_cl=dol.fwid_cl) "
				+ " WHERE  (org.fwid=" + sqlID
				+ " OR (org.fleftkey BETWEEN " + sqlLeftKey + " AND " + sqlRightKey + ") AND org.fwid<>0 ) "
				//+ " AND crc.fcl=" + sqlTo(codPers)
				+ " AND dol_crc.fcl=" + sqlTo(codDol)
				//dol.fcod избыточное поле, код записи мы все равно выбираем напрямую из справочника 
				//+ " AND dol.fcod <> 0 "
				+ addSQL + " AND "
				+ " wp.fbdat<=" + sqlTo(edat) + " AND wp.fedat>=" + sqlTo(bdat)
			);
	/*
	var sIns = "SELECT  fwid, fwid_cl AS ftabn_id, fwid_dol, fbdat, " 
				+ " fedat, fvopl, Ftxtpers as ftxt, "
				+ " fp.Fcodpers as fcod, fp.ftxtdol as fpos, 0 AS fident, fleftkey, frightkey,"
				+ " foklad, fcoddol, finval, fp.fshpz, "
				+ " fid, favans, fcodkat, fis_serv, "
				+ " fis_uv, fis_nazn, fnewrm, FTABLE "
				+ " FROM ^FULL_PERS fp "

				+ " WHERE  (fwid_org=" + sqlID
				+ " OR ((fleftkey BETWEEN " + sqlLeftKey + " AND " + sqlRightKey + ") AND fwid_org <> 0 )) "				
				
				+ addSQL + " AND "
				+ " fbdat<=" + sqlTo(edat) + " AND fedat>=" + sqlTo(bdat)
				
	DropTable("tmp_pers");			
	ExecuteSQL("INSERT INTO " + workTable
				+ " (fwid, ftabn_id, fwid_dol, fbdat, fedat, fvopl, ftxt, fcod, fpos, fident, fleftkey, frightkey, foklad, fcoddol, "
				+ " finval, fshpz, fid, favans, fkodkat, fis_serv, fis_uv, fis_nazn, fnewrm, FTABLE) "
				+ sIns
			);*/
	return true;
}

function showGrid(gridID, selection)
{	
	var absolute = 1;
	if (table != null)
		absolute = table.getAbsolute();
	if (table != null)
		table.close();
	var order = getPar("SHTAT_ORDER");
	var sOrder = "fleftkey, fident DESC, fcoddol, fcod, fid, fbdat, fedat";
	switch(order)
	{
		case 0://по коду должности
			sOrder = "fleftkey, fident DESC, fcoddol, fcod, fid, fbdat, fedat";
		break;
		case 1://по таб.номеру
			if(getPar("TABNORG"))
				sOrder = "fleftkey, fident DESC, ftabnorg, fid, fbdat, fedat";
			else
				sOrder = "fleftkey, fident DESC, fcod, fid, fbdat, fedat";
		break;
		case 2://по ФИО
			sOrder = "fleftkey, fident DESC, ftxt, fcod, fid, fbdat, fedat";
		break;
	}
	table = OpenTable("SELECT * FROM " + workTable
			+ (useFast ? 
				" WHERE fwid=" + sqlID + " OR (fleftkey BETWEEN " + sqlLeftKey + " AND " + sqlRightKey + ")"
					:
				"")
			+ " ORDER BY "+sOrder); 
			
	table.ExtTie("SHTATEXT");			 
	grid.setTable(table);
	grid.DeletePages();
	grid.setXMLFile(gridXml);
	grid.addExtPage();
	
	if (typeof selection != "undefined")
		table.setAbsolute(Number(selection))
	else if (typeof gridID != "undefined")	
	{
		if (!table.findByID(Number(gridID)))
		{
			if (absolute <= table.getRecordCount() + 1)
				table.setAbsolute(absolute);
		}		
	}
	if (isZaval && isMass)
	{
		var tmp = new Array();
		for (var n in arraySelectedIDs)
			if (arraySelectedIDs[n] == true)
				tmp[tmp.length] = Number(n);
		grid.setSelectedIDs(tmp);
	}
	list.tbl = table;
	if(getPar("ZRP_SST") && extSstTblName)
	{
		table.clTie("CL_EXT","="+getPar("ZRP_SST")+",FCOD_SST");
		table.tie(extSstTblName, "EXT_SST", "Fmainwid", "CL_EXT.Fwid");
	}
	grid.build();	
	grid.getGridControl().setVisible(true);	
}

function refreshTreeItem(ID)
{
	if (typeof ID == "undefined")
		ID = currentID;
	var text = getSnap("SELECT ftxt, FLV1, Flv2, Flv3, Flv4, Flv5, Fleftkey, Frightkey FROM ^stru_org WHERE fwid=" + sqlTo(Number(ID)));
	if (text == null)
		var txt = "";
	else
	{
		var snap = getSnap("select count(wp.Fwid) as Fkol " +
				"from ^stru_org so inner join ^stru_dol sd on so.fwid = sd.fwid_org inner join  ^work_pers wp on sd.fwid = wp.fwid_dol  " +
				"where (Fleftkey between "+sqlTo(text[6])
			+" and "+sqlTo(text[7])+") and wp.Fbdat<="+sqlTo(edat)+" and wp.Fedat>="+sqlTo(bdat))
		
		var snap2 = getSnap("select COUNT(distinct wp.Fwid_cl) from all_tabels as s "
				+" inner join ^work_pers as wp on wp.Fwid=s.Fwid "
				+" inner join ^stru_dol as sd on sd.Fwid=wp.Fwid_dol "
				+" inner join ^stru_org as so on so.Fwid=sd.Fwid_org "
				+" where so.Fleftkey between "+sqlTo(text[6]) +" and "+sqlTo(text[7]),false);
			
		var txt = getLvls(text[1],text[2],text[3],text[4],text[5]) 
		if(snap)
			txt += " : " +	(!snap2 || snap[0] == snap2[0] ? (text[0] + " ("+snap[0]+ru(" записей"," записів") + ")") : (text[0] + " ("+snap[0] + " / " + snap2[0] +ru(" записей"," записів") + ")"));
		
	}
	var ti = Tree.getItem(String(ID));
	ti.setText(txt);
}

function refreshTree()
{
	var t = OpenTable("select Fwid from "+treeTbl+" where Fbdat<="+sqlTo(edat)+" and Fedat>="+sqlTo(bdat));
	for(; !t.IsEOF(); t.MoveNext())
	{
		refreshTreeItem(t.getValue("Fwid"));
	}
}

function isGroup(grid)
{
	var snap = getSnap("SELECT fwid FROM ^stru_org WHERE fwid=" + sqlTo(grid.table.getValue("fwid")));
	if (snap == null)
		return false;
	return true;
}

function onTreeMenuInit(toObject)
{
	if (Tree.getItemCount() == 0)
		return;
	myInitMenu(toObject, true, currentID);
	toObject.AddMenuItem("PORDER", "Впорядкувати підрозділи|Упорядочить подразделения");
	toObject.AddMenuItem("", "");
	
}

function listMenuInit(toObject)
{
	if (isZaval && IsDblClick())
	{	
		if (!toScrObj(grid.table.getValue("fident")))
		{
			if (isMass)
			{
				extPar.ret = new Array();
				extPar.ret[0] = toScrObj(grid.table.getValue("fwid"));
			}
			else
			{
				for (var i in extPar.ret)
				try
				{
				   extPar.ret[i] = toScrObj(grid.table.getValue(String(i)));
				}
				catch(x)
				{
					extPar.ret[i] = "error field name";
				}				
			}
			extPar.escape = false;
			CloseWindow();
		}		
		return false;
	}
	
	myInitMenu(toObject, toScrObj(grid.table.getValue("fident")), grid.table.getValue("fwid"));
	
	if (!isEmpty(this.oTblArch))
	{
		if (toScrObj(grid.table.getValue("fident")))
		{
			this.oTblArchG.menuInit("ACED");
		}
		else
		{
			this.oTblArch.menuInit("ACED");
		}
	}
}

function myInitMenu(toObject, isGroup, ID)
{
	if (isGroup)
	{
		if (!useStructMenu)
			return;
		toObject.AddMenuItem("PRINT_PODR","Друк підрозділів|Печать подразделений",9);
		toObject.AddMenuItem("ADD_PODR","Додати підрозділ|Добавить подразделение",0);
		//toObject.AddMenuItem("SET_ORG","Проставить код МВЗ");
		//toObject.AddMenuItem("ADDPERS","Исправление ошибок перекодировки: добавить недостающего сотрудника");
		//toObject.AddMenuItem("SETFWIDPAR","Исправление ошибок перекодировки: назначить пдразделению Fwid_par");
			
		toObject.AddMenuItem("EDIT","Редагувати|Редактировать");
		toObject.AddMenuItem("LIKV","Ліквідувати|Ликвидировать", "del");
		toObject.AddMenuItem("", "");
		
		/*var snap = getSnap("SELECT fwid_par FROM ^stru_org WHERE fwid="
								+ sqlTo(Number(ID)));
		var isPodr = (snap != null && snap[0] != null && snap[0] != 0);
		
		if (isPodr)
		{*/		
			toObject.AddMenuItem("ADDP","Призначити...|Назначить...",0);
			toObject.AddMenuItem("MASS_ADDP","Призначити масово...|Назначить массово...",1);
			toObject.AddMenuItem("", "");
		//}
	}
	else
	{
		if (!usePersonalMenu)
			return;
		toObject.AddMenuItem("ADDP","Призначити...|Назначить...",0);
		toObject.AddMenuItem("MASS_ADDP","Призначити масово...|Назначить массово...",1);
		toObject.AddMenuItem("EDIT_I","Редагувати наказ на призначення|Редактировать приказ на назначение", 2);
		//это меню подключаем только при наличии модуля кадрового планирования CDRP (если есть константа const_GETPAR_PERSONAL, то модуль подключен)
		if(typeof const_GETPAR_PERSONAL != "undefined")
			toObject.AddMenuItem("MOVEPODR","Перевести в інший підрозділ|Перевести в другое подразделение");
		if (differ(toScriptDate(grid.table.getValue("fedat")), toScriptDate(d00)) == 0)
		{
			toObject.AddMenuItem("MOVEP","Перевести...|Перевести...");
			toObject.AddMenuItem("DELP","Звільнити...|Уволить...");	
			toObject.AddMenuItem("", "");
		}
		else
		if(grid.table.getValue("fis_uv") == true)
		{
			toObject.AddMenuItem("DELP","Редагувати наказ на звільнення...|Редактировать приказ на увольнение...", 2);	
			toObject.AddMenuItem("", "");
		}
		else
			toObject.AddMenuItem("", "");
		//var isInPRK = false;
		toObject.AddMenuItem("+++","Сервіс|Сервис");
			toObject.AddMenuItem("NEWDAT","Відкрити ШР з нової дати (зміна окладу)|Открыть ШР с новой даты (изменения оклада)");
			toObject.AddMenuItem("+++","Оклад|Оклад");
				toObject.AddMenuItem("OKLAD","Проставити оклад|Проставить оклад");
				toObject.AddMenuItem("OKLADPROC","Змінити оклад на %|Изменить оклад на %");
				toObject.AddMenuItem("OKLADPROCLAST","Проставити оклад попереднього запису, змінений на %|Проставить оклад предыдущей записи, измененный на %");
			toObject.AddMenuItem("---","");
			toObject.AddMenuItem("+++","Аванс|Аванс");
			toObject.AddMenuItem("AVANS","Проставити аванс як % від окладу|Проставить аванс как % от оклада");
			toObject.AddMenuItem("AVANSPROC","Змінити аванс на %|Изменить аванс на %");
			toObject.AddMenuItem("AVANSPROCLAST","Проставити аванс попереднього запису, змінений на %|Проставить аванс предыдущей записи, измененный на %");
			toObject.AddMenuItem("---","");
			toObject.AddMenuItem("+++","Проставити записи з довідників пенсійного страхування|Проставить записи из справочников пенсионного страхования");
				toObject.AddMenuItem("ZRP_SSV","Коди типів ставок страхового внеску|Коды типов ставок страховых взносов");
				toObject.AddMenuItem("ZRP_KZO","Коди категорій застрахованих осіб|Коды категорий застрахованных лиц");
				toObject.AddMenuItem("ZRP_SST","Коди підстав для обліку стажу окремим категоріям осіб|Коды основания для учета стажа отдельным категориям лиц");
			toObject.AddMenuItem("---","");
			toObject.AddMenuItem("+++","Змінити інші данні|Изменить другие данные");
				//это меню подключаем только при наличии модуля кадрового планирования CDRP (если есть константа const_GETPAR_PERSONAL, то модуль подключен)
				if(typeof const_GETPAR_PERSONAL != "undefined")
					toObject.AddMenuItem("EDIT_LIC_CART","Редагувати особову справу|Редактировать личное дело");
				toObject.AddMenuItem("SETORG","Поміняти підрозділ (якщо помилились при переведенні)|Поменять подразделение (если ошиблись при переводе)");
				if(getPar("TABNORG"))
					toObject.AddMenuItem("SETTABNORG","Поміняти таб.№ по підрозділу (якщо помилились при переведенні)|Поменять таб.№ по подразделению (если ошиблись при переводе)");
				toObject.AddMenuItem("UVOL","Інвертувати ознаку звільнення|Инвентировать признак увольнения");
				toObject.AddMenuItem("NAZN","Інвертувати ознаку прийняття|Инвентировать признак принятия");
				toObject.AddMenuItem("INVAL","Інвертувати ознаку інвалідності|Инвентировать признак инвалидности");
				toObject.AddMenuItem("PENS","Інвертувати ознаку пенсіонера|Инвентировать признак пенсионера");
				toObject.AddMenuItem("VOPL","Встановити вид оплати|Установить вид оплати");
				toObject.AddMenuItem("PODNAL","Встановити значення таблиці прибуткового податку|Установить значение таблицы подоходного налога");
				//toObject.AddMenuItem("SETNULLORG","Исправление ошибок перекодировки: установить для сотрудника нулевую организацию");
				toObject.AddMenuItem("ISSHPZ","Масове проставлення ШВЗ|Массовое проставление ШПЗ");
				toObject.AddMenuItem("ZPRKSHPZ","Проставлення ШВЗ в наказах по значенню з ШР|Проставление ШПЗ в приказах по значению из ШР");
				toObject.AddMenuItem("PRKSHPZ","Проставлення ШВЗ в наказах з ШЗ із замiною ост.знаку|Проставление ШПЗ в приказах из ШР з заменой посл.знака");				
				if(differ(toScriptDate(grid.table.getValue("fedat")), toScriptDate(d00)) == 0)
					toObject.AddMenuItem("CHANGE_DOL","Змінити посаду|Изменить должность");
				toObject.AddMenuItem("SET_CALEND","Проставити календар|Проставить календарь");
				toObject.AddMenuItem("SET_PROP_PRK","Обчисл.пропорцюдні/год. в наказах на дату зміни закон-ва|Вычисл.пропорц.дни/часы в приказах на дату изм.закон-ва");
				toObject.AddMenuItem("SET_PROP_PRK_CAL","Обчисл.пропорцюдні/год. в наказах на дату зміни закон-ва по календарю|Вычисл.пропорц.дни/часы в приказах на дату изм.закон-ва по календарю");
			toObject.AddMenuItem("---","");
		toObject.AddMenuItem("---","");
		/*var fwid = Number(grid.table.getValue("fwid"));
		var fields = new Array();
		fields[0] = "fwid_in";
		if (differ(toScriptDate(d00), toScriptDate(grid.table.getValue("fedat"))) == 1)
			 fields[0] = "fwid_out";
		
		var snap = getSnap("SELECT COUNT(*) FROM ^prk_in WHERE fwid_wp=" + sqlTo(fwid));			
		if (snap[0] == 1)
		{
			snap = getSnap("SELECT COUNT(*) FROM ^prk_outin WHERE fwid_in=" + sqlTo(fwid));			
			if (snap[0] == 0)
			{
				toObject.AddMenuItem("EDIT_I","Редагувати наказ на призначення|Редактировать приказ на назначение", 2);
				isInPRK = true;
			}
			else if (snap[0] == 1 && fields[0] == "fwid_out")
			{
				 fields[0] = "fwid_in";
				 fields[1] = "fwid_out"
			}							
		}
		else if (snap[0] > 1)
		{
			toObject.AddMenuItem("XXXX","ERROR IN");
			isInPRK = true;
		}*/
		
		/*смысла в редактировании приказа на перевод я не вижу, все данные можно редактировать из обычного приказа на назначение 
		for (var i in fields)
		{
			
			var snap = getSnap("SELECT COUNT(*) FROM ^prk_outin WHERE " + fields[i] + "=" + sqlTo(fwid));
			if (snap[0] == 1)
			{
				if (fields[0] == "fwid_out" && !isInPRK)
					toObject.AddMenuItem("EDIT_I","Редагувати наказ на призначення|Редактировать приказ на назначение", 2);
				toObject.AddMenuItem("EDIT_OI_" + i,"Редагувати наказ на переведення|Редактировать приказ на перевод", 2);
				toObject.setData("field" + i, fields[i]);
				isInPRK = true;
			}	
			else if (snap[0] > 1)
			{
					toObject.AddMenuItem("XXXX","ERROR IN_OUT");
					isInPRK = true;	
			}
		}*/
		
		/*if (typeof fields[1] == "undefined" && fields[0] != "fwid_out")
		{
			snap = getSnap("SELECT COUNT(*) FROM ^prk_out WHERE fwid_wp=" + sqlTo(fwid));
			if (snap[0] == 1)
			{
				toObject.AddMenuItem("EDIT_O","Редагувати наказ на звільнення|Редактировать приказ на увольнение", 2);
				isInPRK = true;
			}
			else if (snap[0] > 1)
			{
				toObject.AddMenuItem("XXXX","ERROR OUT");
				isInPRK = true;
			}
		}*/	
		/*if (!isInPRK)
		{
			toObject.AddMenuItem("EDIT_I","Редагувати наказ на призначення|Редактировать приказ на назначение", 2);
			if (differ(toScriptDate(d00), toScriptDate(grid.table.getValue("fedat"))) == 1)
				toObject.AddMenuItem("EDIT_O","Редагувати наказ на звільнення|Редактировать приказ на увольнение", 2);
		}*/
		toObject.AddMenuItem("", "");
		toObject.AddMenuItem("FULLINFO", "Повна інформація по співробітнику|Полная информация по сотруднику");
		toObject.AddMenuItem("SHOW_INFO","Показати історію|Показати историю");
		toObject.AddMenuItem("", "");
	}
	toObject.AddMenuItem("DEL","Вилучити|Удалить", "del");
	toObject.AddMenuItem("", "");
	toObject.AddMenuItem("EXT",ru("Расширения","Розширення"));
}

function onTreeSelectMenuHandler(sID, toObject)
{
	if (isZaval && !sID.equals("PORDER"))
		return;
	switch (sID)
	{
		case "ADD":
			addMenuRun(true, toObject, "onTreeSelectMenuHandler");
			break;
		case "ADDPERS":
		case "SETFWIDPAR":
		case "PRINT_PODR":
		case "ADD_PODR":
		case "EDIT":
		case "LIKV":			
			groupMenuHandler(sID, Number(Tree.getItem(currentID).getData()));
			break;
		case "DEL":			
			deleteMenuHandler(Number(Tree.getItem(currentID).getData()), true);
			break;
		case "ADDP":
			persMenuHandler(sID, toObject, Number(Tree.getItem(currentID).getData()));
			break;
		case "MASS_ADDP":
			persMenuHandler(sID, toObject, Number(Tree.getItem(currentID).getData()));
			break;
		case "PORDER":
			var par = new Object();
			par.escape = true;
			par.fwid_par = Number(Tree.getItem(currentID).getData());
			par.tableName = "tmp_order_podr";
			DropTable(par.tableName);
			ExecuteSQL("SELECT * INTO " + par.tableName + " FROM ^stru_org WHERE fwid_par=" + sqlTo(par.fwid_par));
			showWindow("l_order_podr.xml", SW_MODAL, par);
			if (!par.escape)
			{
				ExecuteSQL("DELETE FROM ^stru_org WHERE fwid IN (SELECT fwid FROM " + par.tableName + ")");				
				var sFld = GetPatternIntersection("stru_org", "stru_org");
				ExecuteSQL("INSERT INTO ^stru_org (" + sFld + ") SELECT " + sFld + " FROM " + par.tableName);
				var expanded = Tree.getExpanded(currentID);
				var useID = currentID;
				buildTreeKeysOnTable(treeTbl, 0, 0, "flv1, flv2, flv3, flv4, flv5", "fwid_par");
				Tree.removeAll();
				list.buildTree();
				currentID = "0";
				Tree.setSelected(useID);
				Tree.setExpanded(useID, expanded);
				onTreeSelected(useID);				
			}
			DropTable(par.tableName);			
			break;
	}
}

function listMenuRun(sID, toObject)
{
	//var nGridPos = grid.table.absolute;
	if (isZaval)
		return;
	switch (sID)
	{
		//меняем родительский орг устанавливая новый Fwid_par
		case "SETFWIDPAR":
			var fwid_par = input("Введите Fwid_par", "", 0, 6);
			if(fwid_par==null)
				return false;
			var snap = getSnap("select Ftxt,fbdat,fedat from ^stru_org where fwid="+sqlTo(fwid_par))
			if(snap==null)
			{
				alert("Подразделения с таким fwid-ом не существует!")
				return false;
			}
			else
			{
				if("y"==msgBox("yn", "Назначить родительским подразделением: \n "+snap[0]+" ("+format("dd.mm.yy",snap[1])+"-"+format("dd.mm.yy",snap[2])+")"))
					ExecuteSQL("update ^stru_org set fwid_par="+sqlTo(fwid_par)+" where fwid="+sqlTo(grid.table.getValue("fwid")));
			}
			fillGrid(list.tbl.getValue("Fwid"));
			break;
		//проставляет в таблице stru_dol должностей fwid_org той организации на которой стоим в ШР
		//апдейтит только те записи, которые входят в период дат штатного расписания 
		case "ADDPERS":
			var fwid_org = grid.table.getValue("fwid");
			var form = createForm(UR("Табельный номер сотрудника"));
			cod = form.addCodPers(false, true)
			form.show();
			if(form.escape)
				return false;
			ExecuteSQL("update ^stru_dol set fwid_org="+sqlTo(fwid_org)+" where (fwid_org=0 or fwid_org is null) and " 
					+" fwid in (select wp.fwid_dol from ^work_pers as wp "
					+" inner join ^clrelclcl as r on wp.fwid_cl=r.fwid_cl "
					+" where r.fcl="+sqlTo(codPers)+" and r.fcod="+sqlTo(cod.getCod())
						+" and wp.Fedat>="+sqlTo(bdat)+" and wp.Fbdat<="+sqlTo(edat)+")");
			buildTreeKeysOnTable("^stru_org", 0, 0, "flv1, flv2, flv3, flv4, flv5", "fwid_par")
			fillGrid(list.tbl.getValue("Fwid"));
			break;
		//для Укрттелеком проставляет в расширение справочника персонала (ORG) код из 21-го справочника МВВ
		case "SET_ORG":
			var form = createForm("Проставление кодов организаций");
			var oMVV = form.addClMVV();
			form.show();
			if(form.escape)
				return false;
			var oExt = new DpExtentionBuilder("CL",String(codPers));
			if(oExt.exist())
			{
				var extTblName = oExt.getValueTableName();
				var snap = getSnap("SELECT Forg FROM "+extTblName);
				if(snap==null)
				{
					alert("Создайте сперва расширение ORG в справочнике персонала на 21-й справочник аналитики!");
					return false;
				}
				var oCl =  new DpClEx("CL3",Number(codPers));
				torg=OpenTable("select * from ^stru_org where "+DataSource().sqlSelected(false))
				for(; !torg.IsEOF(); torg.MoveNext())
				{
					t = OpenTable("select distinct Fwid_cl from ^full_pers "
									+" where Fbdat<="+sqlTo(edat)+" and fedat >="+sqlTo(bdat)
										+" and Fleftkey>= "+torg.getValue("Fleftkey")
										+" and Frightkey<="+torg.getValue("Frightkey"))
					var recCount = t.recordCount;
					var step = 1;
					var maxPos = Math.floor(recCount/step);
					var nPos = 0;
					setProgressRange(0, maxPos);
					for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
					{
						oCl.clear();
						oCl.loadByID(t.getValue("Fwid_cl"));
						oCl.setExt("ORG", oMVV.getCod());
						oCl.saveExtToDB();
						nPos++;
						if(nPos % step == 0)
							setProgressPos(Math.floor(nPos/step), "Кол-во обновлённых сотрудников: "+nPos+" из "+recCount+" в "+torg.bookmark+" подразделении");
					}
					t.close();
					setProgressPos(0);
				}
				torg.close();
				alert(ru("Обновление расширения ORG в справочнике сотрудников окончено."));
			}
			break;
		case "ADD":
			addMenuRun(isGroup(grid), toObject, "listMenuRun");
			break;
		case "EDIT":
			if (!isGroup(grid))
			{
				listMenuRun("EDIT_I", toObject);
				break;
			}
		case "ADD_PODR":
		case "PRINT_PODR":
		case "LIKV":										
			groupMenuHandler(sID, toScrObj(grid.table.getValue("fwid")));
			break;
		case "DEL":			
			deleteMenuHandler(toScrObj(grid.table.getValue("fwid")), toScrObj(grid.table.getValue("fident")), toScrObj(grid.table.getValue("ftabn_id")), toScrObj(grid.table.getValue("fbdat")), toScrObj(grid.table.getValue("fedat")));
			break;
		case "SHOW_INFO":
			var par = new Object();
			par.fwid = toScrObj(grid.table.getValue("fwid"));
			showWindow("l_persInfo.js", SW_MODAL, par);
			break;
		case "FULLINFO":
			var par = new Object();
			par.fwid_wp = toScrObj(grid.table.getValue("fwid"));
			var gdat = new DpGetDat("d");
			if (gdat.escape == true)
				return false;
			par.dat1 = gdat.dat1;
			showWindow("f_liccs.xml", SW_NOMODAL, par);
		break;
		case "OKLAD":
			var oklad = input(ru("Введите оклад","Введіть оклад"), "", 0, 5,2);
			if(oklad==null)
				return false;
			ExecuteSQL("UPDATE ^stru_dol SET Foklad="+sqlTo(oklad)
					+" WHERE Fwid in (SELECT Fwid_dol FROM ^work_pers WHERE "+DataSource().sqlSelected(false)+")");
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "AVANS":
			var p = new Object();
			p.escape=true;
			p.mProc=0;
			p.mRound=0;
			p.mSum_val=true;
			showWindow("g_round.xml",SW_MODAL,p)
			if(p.escape)
				return false;
			ExecuteSQL("UPDATE ^work_pers SET Favans="+sqlRound("(select Foklad from ^stru_dol as sd where sd.Fwid=^work_pers.Fwid_dol)/100*"+sqlTo(p.mProc),p.mRound)
				+" WHERE "+DataSource().sqlSelected(false));
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "OKLADPROC":
			//var proc = input(ru("Введите процент на который нужно увеличить оклад","Введіть відсоток на який треба збільшити оклад"), "", 0, 5,2);
			var p = new Object();
			p.escape=true;
			p.mProc=0;
			p.mRound=0;
			p.mSum_val=true;
			showWindow("g_round.xml",SW_MODAL,p)
			if(p.escape)
				return false;
			ExecuteSQL("UPDATE ^stru_dol SET Foklad="+sqlRound("Foklad+Foklad/100*"+sqlTo(p.mProc),p.mRound)
					+" WHERE Fwid in (SELECT Fwid_dol FROM ^work_pers WHERE "+DataSource().sqlSelected(false)+")");
			if(confirm(ru("Изменить аванс на тот же процент?","Змінити аванс на той же відсоток?")))
			{
				ExecuteSQL("UPDATE ^work_pers SET Favans="+sqlRound("Favans+Favans/100*"+sqlTo(p.mProc),p.mRound)+" WHERE "+DataSource().sqlSelected(false));
			}
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "AVANSPROC":
			//var proc = input(ru("Введите процент на который нужно увеличить аванс","Введіть відсоток на який треба збільшити аванс"), "", 0, 5,2);
			var p=new Object();
			p.escape=true;
			p.mProc=0;
			p.mRound=0;
			p.mSum_val=true;
			showWindow("g_round.xml",SW_MODAL,p)
			if(p.escape)
				return false;
			ExecuteSQL("UPDATE ^work_pers SET Favans="+sqlRound("Favans+Favans/100*"+sqlTo(p.mProc),p.mRound)+" WHERE "+DataSource().sqlSelected(false));
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "OKLADPROCLAST":
			var p = new Object();
			p.escape=true;
			p.mProc=0;
			p.mRound=0;
			p.mSum_val=true;
			showWindow("g_round.xml",SW_MODAL,p)
			if(p.escape)
				return false;
			tbn = OpenTable("SELECT * FROM ^work_pers WHERE "+DataSource().sqlSelected(false))
			for(; !tbn.IsEOF(); tbn.MoveNext())
			{
				ExecuteSQL("UPDATE ^stru_dol SET Foklad=(select "+sqlRound("Foklad+Foklad/100*"+sqlTo(p.mProc),p.mRound)+" from ^full_pers "
						+" where Fwid_cl="+tbn.getValue("Fwid_cl")+" and Fid="+(tbn.getValue("Fid")-1)+") WHERE Fwid="+sqlTo(tbn.getValue("Fwid_dol")));
			}
			if(confirm(ru("Изменить аванс на тот же процент?","Змінити аванс на той же відсоток?")))
			{
				ExecuteSQL("UPDATE ^work_pers SET Favans=(select "+sqlRound("Favans+Favans/100*"+sqlTo(p.mProc),p.mRound)+" from ^full_pers as f "
						+" where f.Fwid_cl=^work_pers.Fwid_cl and f.Fid=^work_pers.Fid-1) WHERE "+DataSource().sqlSelected(false));
			}
			tbn.close();
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "AVANSPROCLAST":
			var p=new Object();
			p.escape=true;
			p.mProc=0;
			p.mRound=0;
			p.mSum_val=true;
			showWindow("g_round.xml",SW_MODAL,p)
			if(p.escape)
				return false;
			ExecuteSQL("UPDATE ^work_pers SET Favans=(select "+sqlRound("Favans+Favans/100*"+sqlTo(p.mProc),p.mRound)+" from ^full_pers as f "
						+" where f.Fwid_cl=^work_pers.Fwid_cl and f.Fid=^work_pers.Fid-1) WHERE "+DataSource().sqlSelected(false));
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "SETORG":
			var msg = ru("Использовать этот сервис только если ошиблись при назначении или переводе!\nПродолжить?",
						"Використовувати цей сервіс тільки якщо помилились при призначенні або переведенні!\nПродовжити?")
			if(!confirm(msg))
				return false;
			//выберем подразделения
			var par = new Object();
			par.zaval = true;
			par.escape = false;
			par.ret = new Object();
			par.ret.fwid = 0;
			par.ret.ftxt = "";
			par.ret.fleftkey = 0;
			par.ret.frightkey = 0;
			par.dat = bdat;
			showWindow("l_struOrg.js",SW_MODAL,par);
			if(par.escape)
				return false;
			if(!par.ret.fwid)
			{
				alert(ru("Ошибка, не определен идентификатор подразделения!","Помилка, не визначен ідентифікатор пірозділу!"))
				return false;
			}
			var msg = ru("Перевести сотрудника в подразделение:\n"+par.ret.ftxt+"?",
						"Перевести співробітника в підрозділ:\n"+par.ret.ftxt+"?")
			if(!confirm(msg))
				return false;
			ExecuteSQL("update ^stru_dol set Fwid_org="+par.ret.fwid+" where Fwid="+list.tbl.getValue("Fwid_dol"));
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "SETTABNORG":
			var snap = getSnap("SELECT fwid_org FROM ^full_pers WHERE fwid=" + sqlTo(list.tbl.getValue("fwid")));
			if(snap)
			{
				var tabn = getNextTabnOrg(snap[0]);
				tabn = input(ru("Введите новый таб.№","Введіть новий таб.№"), "", tabn, 8);
				if(tabn>0)
				{
					ExecuteSQL("update ^work_pers set Ftabnorg="+tabn+" where Fwid="+list.tbl.getValue("fwid"));
					fillGrid(list.tbl.getValue("Fwid"));
				}
			}
		break;
		case "UVOL":
			if(!confirm(ru("Вы уверены, что хотите инвертировать признак увольнения?","Ви впевнені, що бажаєте інвертувати ознаку звільнення?")))
				return false;
			ExecuteSQL("UPDATE ^work_pers SET Fis_uv="+IIF("Fis_uv="+sqlTrue,sqlFalse,sqlTrue)+" WHERE "+DataSource().sqlSelected(false));
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "NAZN":
			if(!confirm(ru("Вы уверены, что хотите инвертировать признак принятия?","Ви впевнені, що бажаєте інвертувати ознаку прийняття?")))
				return false;
			ExecuteSQL("UPDATE ^work_pers SET Fis_nazn="+IIF("Fis_nazn="+sqlTrue,sqlFalse,sqlTrue)+" WHERE "+DataSource().sqlSelected(false));
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "INVAL":
			if(!confirm(ru("Вы уверены, что хотите инвертировать признак инвалидности?","Ви впевнені, що бажаєте інвертувати ознаку інвалідності?")))
				return false;
			ExecuteSQL("UPDATE ^work_pers SET Finval="+IIF("Finval="+sqlTrue,sqlFalse,sqlTrue)+" WHERE "+DataSource().sqlSelected(false));
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "PENS":
			if(!confirm(ru("Вы уверены, что хотите инвертировать признак пенсионера?","Ви впевнені, що бажаєте інвертувати ознаку пенсіонера?")))
				return false;
			ExecuteSQL("UPDATE ^work_pers SET Fpens="+IIF("Fpens="+sqlTrue,sqlFalse,sqlTrue)+" WHERE "+DataSource().sqlSelected(false));
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "VOPL":
			var fvopl = input(ru("Введите вид оплаты","Введіть вид оплати"), "", 0, 4);
			if(fvopl==null)
				return false;
			var snap = getSnap("select Fwid from ^cl_vopl where Fvopl<9000 and Fvopl="+fvopl)
			if(!snap)
			{
				alert(ru("Такого вида оплаты не существует.","Такого виду оплати не існує."),2);
				return false;
			}
			ExecuteSQL("UPDATE ^work_pers SET Fvopl="+fvopl+" WHERE "+DataSource().sqlSelected(false));
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "PODNAL":
			var codtbl = input(ru("Введите код таблицы","Введіть код таблиці"), "", 0, 1);
			if(codtbl==null)
				return false;
			tbn = OpenTable("SELECT * FROM ^work_pers WHERE "+DataSource().sqlSelected(false))
			for(; !tbn.IsEOF(); tbn.MoveNext())
			{
				ExecuteSQL("UPDATE ^work_pers SET Ftable="+codtbl+" WHERE Fwid="+sqlTo(tbn.getValue("Fwid")));
			}
			tbn.close();
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "ISSHPZ":
			var cshpz = input(ru("Введите ШПЗ","Введіть ШВЗ"), "", '', 15);
			if(cshpz==null)
				return false;
	
			tbn = OpenTable("SELECT * FROM ^work_pers WHERE "+DataSource().sqlSelected(false))
			for(; !tbn.IsEOF(); tbn.MoveNext())
			{
				ExecuteSQL("UPDATE ^stru_dol SET Fshpz="+sqlTo(cshpz)+" WHERE Fwid="+sqlTo(tbn.getValue("Fwid_dol")));
			}
			tbn.close();
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "ZPRKSHPZ":
			tbn = OpenTable("SELECT DISTINCT wp.Fwid_cl, sd.Fshpz FROM ^work_pers as wp INNER JOIN ^stru_dol as sd ON wp.Fwid_dol=sd.Fwid WHERE wp.Fwid "+DataSource().sqlSelected(true))
			for(; !tbn.IsEOF(); tbn.MoveNext())
			{
				ExecuteSQL("UPDATE ^prk_all SET Fshpz="+sqlTo(tbn.getValue("Fshpz"))
							+" WHERE Ftabn_id="+sqlTo(tbn.getValue("Fwid_cl")));
			}
			tbn.close();
			alert(ru("Обновление приказов окончено","Оновлення наказів завершено"));
		break;
		case "PRKSHPZ":
			tbn = OpenTable("SELECT DISTINCT wp.Fwid_cl, sd.Fshpz FROM ^work_pers as wp INNER JOIN ^stru_dol as sd ON wp.Fwid_dol=sd.Fwid WHERE wp.Fwid "+DataSource().sqlSelected(true)+" and sd.Fshpz is not null and sd.Fshpz<>"+sqlTo("0"))
			for(; !tbn.IsEOF(); tbn.MoveNext())
			{
				ExecuteSQL("UPDATE ^prk_all SET Fshpz="+sqlTo(tbn.getValue("Fshpz"))
							+" WHERE Ftabn_id="+sqlTo(tbn.getValue("Fwid_cl")));
			}
			tbn.close();
			//перебиваем отдельно ШПЗ, которым нужно заменить последний символ
			var t = OpenTable("select p.*,l.Fan from ^prk_all as p inner join ^cl_prik as c on p.Fvid_prk=c.Fvid "
									+" inner join ^lic_fld as l on c.Flsfid=l.Fid and l.Fan>0"
							+" where p.Ftabn_id in (select Fwid_cl from ^work_pers where Fwid"+DataSource().sqlSelected(true)+")");
			for(; !t.IsEOF(); t.MoveNext())
			{
				var hpz = t.getValue("Fshpz");
				var zat = t.getValue("Fan");	
				if (zat != 0 && hpz != 0)
				{
					//*заменить (или добавить в конец) последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
					switch(getPar("PRK_SHPZ"))
					{
						case 1:
							hpz = hpz + allt(String(zat));
						break;
						case 0:
						default:
							hpz = allt(String(hpz)).substring(0, allt(String(hpz)).length - 1) + allt(String(zat));
						break;
					}
					ExecuteSQL("update ^prk_all set Fshpz="+sqlTo(hpz)+" where Fwid="+t.getValue("Fwid"));
				}
			}
			t.close();
			alert(ru("Обновление приказов окончено","Оновлення наказів завершено"));
		break;
		case "CHANGE_DOL":
			var fwid = list.tbl.getValue("Fwid");
			if(!confirm(ru("Используйте этот пункт меню, только если вы ошиблись при выборе должности!\nВ остальных случаях используйте пункт меню перевода на новую должность.\nПродолжить?",
						"Використовуйте цей пункт меню, тільки якщо ви помилились при обранні посади!\nв іших випадках використовуйте пункт меню переведення на нову посаду.\nПродовжити?")))
				return false;
			var form = createForm(UR("Виберіть нову посаду|Выберите новую должность"));
			var oDol = form.addCodDol(false,true);
			form.show();
			if(form.escape)
				return false;
			var tbl = OpenTable("SELECT * FROM ^work_pers WHERE "+DataSource().sqlSelected(false))
			for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{
				var fwid = tbl.getValue("Fwid");
				var snap = getSnap("select Fwid_dol from ^work_pers where Fwid="+fwid);
				if(snap && oDol.getFWID())
				{
					var m = new Object();
					m.Fcod = oDol.getCod();
					m.Fwid_cl = oDol.getFWID();
					UpdateTable("^stru_dol", m, false, "Fwid="+snap[0]);
				}
			}
			fillGrid(fwid);
		break;
		case "SET_PROP_PRK":
			var form = createForm(ru("Введите данные","Введіть дані"));
			var ctrldat1 = form.addObj("dat1","date",UR("Дата зміни в законодавстві|Дата изменения законодательства"));
			ctrldat1.setValue(getPar("GLOBDAT1"));
			//oCal = form.addCalendar();
			form.show();
			if(!form.escape)
			{
				var tbl = OpenTable("SELECT p.Fwid,p.Fbdat,p.Fedat,wp.Fcalend,r.Fcod "
						+" FROM ^prk_all AS p inner join ^work_pers as wp on p.Ftabn_id=wp.Fwid_cl "
							+" inner join ^clrelclcl as r on wp.Fwid_cl=r.Fwid_cl "
						+" WHERE wp.Fwid "+grid.sqlSelected(true)
							+" AND p.Fbdat<="+sqlTo(form.dat1)
							+" AND p.Fedat>="+sqlTo(firstDayMonth(form.dat1)));
				var j = 0;
				var k = 0;
				for(; !tbl.IsEOF(); tbl.MoveNext())
				{
					var bd = tbl.getValue("Fbdat");
					var ed = tbl.getValue("Fedat");
					if(differ(form.dat1,ed)<0)
						ed = form.dat1;
					if(tbl.getValue("Fcalend")>0)
					{
						var m = new Object();
						m.Fday_prop = getWorkDays(tbl.getValue("Fcalend"),bd,ed);
						//m.Fchas_prop = getWorkHours(tbl.getValue("Fcalend"),bd,form.dat1);
						UpdateTable("^prk_all", m, false, "Fwid="+tbl.getValue("Fwid"));
						j++;
					}
					else
					{
						WAIT(ru("В ШР не проставлен календарь для таб.№ ","В ШР не проставлений календар для таб.№ ")+tbl.getValue("Fcod"));
						k++;
					}
				}
				tbl.close();
				alert(ru("Кол-во обновленных приказов: ","Кількість оновлених наказів: ")+j);
				if(k>0 && confirm("Для "+k+ru(" таб.№ не проставлен календарь в ШР!\nПоказать их список?"," таб.№ не проставлено календар в ШР!\nПоказати їх список?")))
				{
					var t = OpenTable("SELECT r.Fcod,cl.Ftxt,wp.Fbdat,wp.Fedat "
					+" FROM ^prk_all AS p inner join ^work_pers as wp on p.Ftabn_id=wp.Fwid_cl "
						+" inner join ^clrelclcl as r on wp.Fwid_cl=r.Fwid_cl "
						+" inner join ^cl as cl on cl.Fwid=r.Fwid_cl "
					+" WHERE wp.Fwid "+grid.sqlSelected(true)
						+" AND p.Fbdat<="+sqlTo(form.dat1)
						+" AND p.Fedat>="+sqlTo(form.dat1)
						+" AND wp.Fcalend=0 OR wp.Fcalend is null"
					+" ORDER by r.Fcod,Fbdat");
					var par = new Object();
					par.cells = new Object();
					par.caption = UR("Персонал з відсутнім календарем|Персонал с отсутствующим календарем");
				
					par.cells[1] = new Object();
					par.cells[1].name = "Fcod";
					par.cells[1].width = 3;
					par.cells[1].text = UR("Таб.№|Таб.№");
				
					par.cells[2] = new Object();
					par.cells[2].name = "Ftxt";
					par.cells[2].width = 15;
					par.cells[2].text = UR("ФИО|ПІБ");	
					
					par.cells[3] = new Object();
					par.cells[3].name = "Fbdat";
					par.cells[3].width = 10;
					par.cells[3].text = UR("Дата поч.|Дата нач.");
					
					par.cells[4] = new Object();
					par.cells[4].name = "Fedat";
					par.cells[4].width = 10;
					par.cells[4].text = UR("Дата зак.|Дата оконч.");
					browse(t, par, SW_MODAL);
					t.close();
				}
			}
		break;
		case "ZRP_SSV":
		case "ZRP_KZO":
		case "ZRP_SST":
			var fcl = getPar(sID);
			var Fld = sID.replace("ZRP_","FCOD_")
			if(fcl)
			{
				var snap = getSnap("select Ftxt from ^clcl where Fcod="+fcl);
				var form = createForm(snap?UR(snap[0]):ru("Введите данные","Введіть дані"));
				var oCl = form.addObjCl(fcl,"0",true);
				form.show();
				if(!form.escape)
				{
					ExecuteSQL("update ^work_pers set "+Fld+"="+oCl.getCod()+" where "+grid.sqlSelected(false))
					fillGrid(list.tbl.getValue("Fwid"));
				}
			}
			else
			{
				alert(ru("В параметрах системы не указаны справочники для пенсионного страхования!",
						"У параметрах системи не вказані довідники для пенсійного страхування!"));
				return false;
			}
		break;
		case "SET_PROP_PRK_CAL":
			var form = createForm(ru("Введите данные","Введіть дані"));
			var ctrldat1 = form.addObj("dat1","date",UR("Дата зміни в законодавстві|Дата изменения законодательства"));
			ctrldat1.setValue(getPar("GLOBDAT1"));
			oCal = form.addCalendar();
			form.show();
			if(!form.escape)
			{
				var tbl = OpenTable("SELECT p.Fwid,p.Fbdat,p.Fedat,wp.Fcalend,r.Fcod "
						+" FROM ^prk_all AS p inner join ^work_pers as wp on p.Ftabn_id=wp.Fwid_cl "
							+" inner join ^clrelclcl as r on wp.Fwid_cl=r.Fwid_cl "
						+" WHERE wp.Fwid "+grid.sqlSelected(true)
							+" AND p.Fbdat<="+sqlTo(form.dat1)
							+" AND p.Fedat>="+sqlTo(firstDayMonth(form.dat1)));
				var j = 0;
				for(; !tbl.IsEOF(); tbl.MoveNext())
				{
					var bd = tbl.getValue("Fbdat");
					var ed = tbl.getValue("Fedat");
					if(differ(form.dat1,ed)<=0)
						ed = goDay(form.dat1,-1);
					var m = new Object();
					m.Fday_prop = getWorkDays(oCal.getCod(),bd,ed);
					//m.Fchas_prop = getWorkHours(tbl.getValue("Fcalend"),bd,form.dat1);
					UpdateTable("^prk_all", m, false, "Fwid="+tbl.getValue("Fwid"));
					j++;
				}
				tbl.close();
				alert(ru("Кол-во обновленных приказов: ","Кількість оновлених наказів: ")+j);
			}
		break;
		case "SET_CALEND":
			var form = createForm(ru("Введите данные","Введіть дані"));
			oCal = form.addCalendar(true);
			form.show();
			if(!form.escape)
			{
				ExecuteSQL("update ^work_pers set Fcalend="+oCal.getCod()+" where "+grid.sqlSelected(false));
				fillGrid(list.tbl.getValue("Fwid"));
			}
		break;
		case "SETNULLORG":
			tbn = OpenTable("SELECT * FROM ^work_pers WHERE "+DataSource().sqlSelected(false))
			for(; !tbn.IsEOF(); tbn.MoveNext())
			{
				ExecuteSQL("UPDATE ^stru_dol SET Fwid_org=0 WHERE Fwid="+sqlTo(tbn.getValue("Fwid_dol")));
			}
			tbn.close();
			fillGrid(list.tbl.getValue("Fwid"));
		break;
		case "EXT":
			var p = new Object();
			p.vid = "SHTATEXT";
			p.FORM = FORM;
			showWindow("l_extent.js", SW_NOMODAL, p);
		break;
		case "NEWDAT":
			if(!confirm(ru("Отрытие ШР с новой даты используйте только при необходимости изменения оклада!\nПродолжить?",
							"Відкриття ШР з нової дати використовуйте тільки при потребі зміни окладу!\nПродовжити?")))
				return false;
			if(!askPwd())
			{
				alert("Неверный пароль.");
			}
			else
			{
				var isOklad = false;
				var isAvans = false;
				var isPrik = false;
				if(confirm(ru("Изменить оклад на процент от предыдушего оклада?",
								"Змінити оклад на відсоток від минулого окладу?")))
				{
					isOklad = true;
					var p = new Object();
					p.escape=true;
					p.mProc=0;
					p.mRound=0;
					p.mSum_val=true;
					showWindow("g_round.xml",SW_MODAL,p)
					if(p.escape)
						return false;
					if(confirm(ru("Изменить аванс на тот же процент?",
								"Змінити аванс на той же відсоток?")))
						isAvans = true;
				}
				if(confirm(ru("Перезаписать приказы на новый код штатного расписания?",
							"Перезаписати накази на новий код штатного розкладу?")))
					isPrik = true;
				var newdat = new DpGetDat("d");
				if (!newdat.escape)
				{
					var bDat = new Date(newdat.dat1);
					var eDat = new Date(bDat.getFullYear(),bDat.getMonth(),bDat.getDate()-1);
					var strSQLFwids = DataSource().sqlSelected(false);
					tbn = OpenTable("SELECT * FROM ^work_pers as wp WHERE "+strSQLFwids
							//нужно учесть при перезаписи на новую дату также и контрактников с проставленной датой окончания
							+" AND Fbdat<"+sqlTo(bDat)+" AND Fedat>"+sqlTo(bDat)+" and Fid=(SELECT MIN(Fid) FROM ^full_pers as f WHERE f.Fwid=wp.Fwid AND f.Fbdat<"+sqlTo(bDat)+" AND f.Fedat>"+sqlTo(bDat)+")")
					if (!tbn.IsEmpty())
					{
						tbn.MoveFirst();
						var m = new Object();
						var n = new Object();
						while (!tbn.IsEOF())
						{
							if (differ(new Date(tbn.getValue("FBDAT")),bDat)<0 && differ(new Date(tbn.getValue("FEDAT")),bDat)>=0)
							{
								dol = getSnap("SELECT Fwid_org,Fcod,Foklad,Fedat,Fbdat,Fwid_cl,Fshpz "
											+" FROM ^stru_dol WHERE Fwid="+sqlTo(tbn.getValue("Fwid_dol")));
								if(dol!=null)
								{
									//обрабатываем ситуацию, когда дата начала выпадает на первое число, а у сотрудника уже сформирован табель на этот месяц
									if(!canSaveShtat("NEW",tbn.getValue("FWID"),tbn.getValue("FWID_CL"),bDat))
										return false;
									//добавляем новую должность копируя старую
									//по логике начальную дату в stru_dol ставим такой же 
									//как и в work_pers, а конечную в предыдущей записи закрываем
									n.FWID = GetUID();
									n.FWID_ORG = dol[0];
									n.FCOD = dol[1];
									n.FOKLAD = dol[2];
									//n.FEDAT = dol[3];
									//n.FBDAT = dol[4];
									n.FBDAT = bDat;
									n.FWID_CL = dol[5];
									n.FSHPZ = dol[6];
									UpdateTable("^stru_dol",n,true);
									//добавляем новую запись в ШР с кодом новой должности
									m = scatter(tbn);
									var old_fwid = m.FWID;
									m.FWID = GetUID();
									m.FWID_DOL = n.FWID;
									m.FBDAT = bDat;
									//m.FIS_UV = sqlFalse;
									//m.FNAZN = sqlFalse;
									m.FIS_NAZN = 0;
									m.FIS_UV = 0;
									m.FNAZN = 0;
									var snap = getSnap("select MAX(Fid) from ^work_pers where Fwid_cl="+tbn.getValue("FWID_CL"));
									if(snap)
										m.FID = Number(snap[0])+1;
									else
										m.FID += 1;
									m.FREASON = ru("підвищення окладу","повышение оклада")
									UpdateTable("^work_pers", m, true);
								
									//добавляем новую запись в таблицу расширений, если есть
									var oExt = new DpExtentionBuilder("SHTATEXT");
									if(oExt.exist())
									{
										var tblExt = oExt.getValueTableName();
										var snap = getSnap("select Fmainwid from "+tblExt+" where Fmainwid="+old_fwid, false);
										if(snap)
										{
											var e = new Object();
											var tExt = OpenTable("select * from "+tblExt+" where Fmainwid="+old_fwid);
											e = scatter(tExt);
											e.FWID = GetUID();
											e.FMAINWID = m.FWID;
											UpdateTable(tblExt, e, true);
											tExt.close();
										}
									}
									//проставляем дату закрытия 
									ExecuteSQL("UPDATE ^work_pers SET Fedat="+sqlTo(eDat)+" WHERE Fwid="+sqlTo(tbn.getValue("Fwid")));
									ExecuteSQL("UPDATE ^stru_dol SET Fedat="+sqlTo(eDat)+" WHERE Fwid="+sqlTo(tbn.getValue("Fwid_dol")));
									
									if(isOklad && p!=null)//увеличиваем оклад
									{
										ExecuteSQL("UPDATE ^stru_dol SET Foklad="+sqlRound("Foklad+Foklad/100*"+sqlTo(p.mProc),p.mRound)+" WHERE Fwid="+sqlTo(m.FWID_DOL));
										if(isAvans)//увеличиваем аванс
											ExecuteSQL("UPDATE ^work_pers SET Favans="+sqlRound("Favans+Favans/100*"+sqlTo(p.mProc),p.mRound)+" WHERE Fwid="+sqlTo(m.FWID));
									}
									
									if(isPrik)//перезаписываем приказы
										overWritePrik(old_fwid,m.FWID,bDat,eDat,true);
								}
							}
							else
								alert(ru("Дата открытия некоректна для табельного №","Дата вікриття некоректна для табельного №")+getCodFromID(tbn.getValue("Fwid_cl")));
							tbn.MoveNext();
						}
					}
					tbn.close();
					fillGrid(list.tbl.getValue("Fwid"));
				}
			}
			break;
		case "ADDP":
		case "MASS_ADDP":
		case "MOVEP":
		case "MOVEPODR":
		case "DELP":
		case "EDIT_I":
		case "EDIT_O":
		default:
			var snap = getSnap("SELECT fwid FROM ^stru_org WHERE fwid=" + sqlTo(grid.table.getValue("fwid")));
			if (snap == null)
				snap = getSnap("SELECT fwid_org FROM ^stru_dol WHERE fwid=" + sqlTo(grid.table.getValue("fwid_dol")));
			if (snap == null)
				return;
			var ID = Number(snap[0]);
			snap = getSnap("SELECT fwid_par FROM ^stru_org WHERE fwid="	+ sqlTo(ID));
			//var isPodr = (snap != null && snap[0] != null && snap[0] != 0);
			var isStructur = (snap != null);
			if (isStructur)
				persMenuHandler(sID, toObject, ID);
			//fillGrid(list.tbl.getValue("Fwid"));
	}
	//grid.table.requery();
	//grid.table.absolute = nGridPos;
//trace("nGridPos="+nGridPos+"   grid.table.absolute="+grid.table.absolute)
}

function podr_valid()
{
	if (pers.getValue() == false)
		podr.setValue(true);
	else if (podr.getValue() == true)
		pers.setValue(false);
}

function pers_valid()
{
	if (podr.getValue() == false)
		pers.setValue(true);
	else if (pers.getValue() == true)
		podr.setValue(false);
}

function addMenuRun(isGroup, obj, functionName)
{
	if (!isGroup)
		listMenuRun("ADDP", obj);
	else
	{
		var form = createForm(UR("Додавання|Добавление"));
		var podr = form.addObj("podr", "bool", UR("Додати підрозділ |Добавить подразделение "));
		podr.setValue(true);
		var pers = form.addObj("pers", "bool", UR("Призначити на посаду |Назначить на должность"));
		form.setFormValid(podr, podr_valid);
		form.setFormValid(pers, pers_valid);
		form.show();
		if (form.escape == false)
		{
			if (toScrObj(form.pers))
				evalFunction(functionName, new Array("ADDP", obj));
			else
				evalFunction(functionName, new Array("ADD_PODR", obj));
		}
	}	
}

function deleteMenuHandler(ID, isGroup, ftabn_id, fbdat, fedat)
{
	if (!isGroup)
	{
		if(!confirm(UR(
		"Увага!\nНе вилучайте запис при зміні окладу, посади та іншої інформації про співробітника, натомість проставляйте дату закриття."
			+ "\nВидаляйте запис тільки в тому випадку, якщо вона була введена помилково.\nПродовжити видалення?"
		+ "|Внимание!\nНе удаляйте запись при изменении оклада, должности и другой информации о сотруднике, вместо этого проставляйте дату закрытия."
			+ "\nУдаляйте запись только в том случае, если она была введена ошибочно.\nПродолжить удаление?")))
			return false;
		var gS = getSnap("SELECT p.Fvid_prk, p.Fbdat, p.Fedat, p.Fsum, p.Fin_table, cl.Fnazv FROM ^prk_all as p left join ^cl_prik as cl on p.Fvid_prk=cl.Fvid "
					+" WHERE (Fwid_wp="+sqlTo(ID)
								+" or (Ftabn_id="+sqlTo(ftabn_id)+" and (Fwid_wp=0 or Fwid_wp is null)))"
							+" and Fbdat<="+sqlTo(fedat)
							+" and Fedat>="+sqlTo(fbdat)
							+" and ftabn_id<>0");
		if(gS!=null)
		{
			alert(ru("Нельзя удалить запись, т.к. на данного сотрудника существует как минимум 1 приказ \n'"+UR(gS[5]).toUpperCase()+"' код: "
					,"Неможна вилучити запис, томущо на даного співробітника існує як мінімум 1 наказ \n'"+UR(gS[5]).toUpperCase()+"' код: ")+gS[0]
					+ru("\nпериод: ","\nперіод: ")+format("dd.mm.yy",gS[1])+"-"+format("dd.mm.yy",gS[2])
					+ru("\nсумма: ","\nсума: ")+gS[3]+ru("\nтабличная метка: ","\nтаблична мітка: ")+gS[4],ICON_ERROR);
			return false;
		}
	}
	else
	{
		if(!confirm(UR(
			"Увага!\nВидаляйте підрозділ тільки в тому випадку, якщо він був введений помилково."
			+"\nВ іншому випадку проставляйте дату ліквідації.\nПродовжити видалення?"
			+"|Внимание!\nУдаляйте подразделение только в том случае, если оно было введено ошибочно."
			+"\nВ противном случае проставляйте дату ликвидации.\nПродолжить удаление?")))
			return false;
		var gS = getSnap("SELECT Fwid_par, Fleftkey, Frightkey FROM ^stru_org WHERE fwid="+sqlTo(Number(ID)))
		if(gS!=null)
		{
			if(gS[0]==0)
			{
				alert(UR("Неможна вилучати корневий підрозділ!|Нельзя удалять корневое подразделение!"),ICON_WARNING);
				return false;
			}
			else
			{
				var snap = getSnap("SELECT COUNT(Fwid) FROM ^stru_org WHERE Fleftkey >"+sqlTo(gS[1])+" AND Frightkey<"+sqlTo(gS[2]));
				if(snap!=null && snap[0]>0)
				{
					alert(ru("Данное подразделение имеет ","Даний підрозділ має ")+snap[0]+ru(" вложенных подразделений!"," вложених підрозділів!"),ICON_WARNING);
					return false;
				}
				var snap = getSnap("SELECT COUNT(Fwid) FROM ^stru_dol WHERE Fwid_org="+sqlTo(Number(ID)))
				if(snap!=null && snap[0]>0)
				{
					alert(ru("В данном подразделении существует ","В даному підрозділі існує ")+snap[0]+ru(" должностей!"," посад!"),ICON_WARNING);
					return false;
				}
			}
		}
	}		
	if ("-" == msgBox("&c-", UR("Підтвердіть вилучення запису|Подтвердите удаление записи"), UR("Вилучення запису|Удаление записи")))
	{
		parID = "0";
		var snap = getSnap("SELECT fwid_par FROM ^stru_org WHERE fwid=" + sqlTo(Number(ID)));
		if (snap != null)
			parID = String(snap[0]);
		var expanded = false;
		if (parID != "0")
			expanded = Tree.getExpanded(parID);
		var orgID = 0;
		
		if (!isEmpty(list.oTblArch))
		{
			if (isGroup)
			{
				list.oTblArchG.toArchive("DEL", getSysName(), toScrObj(ID));
			}
			else
			{
				var id_dol = getSnap("SELECT FWID_DOL FROM ^WORK_PERS WHERE FWID = "+toScrObj(ID))[0];
				list.oTblArch.toArchive("DEL", getSysName(), toScrObj(ID), "^WORK_PERS");
				list.oTblArch.toArchive("DEL", getSysName(), id_dol, "^STRU_DOL");
			}
		}
		
		if (!isGroup)
		{
			var snap = getSnap("select Fwid_org from ^stru_dol WHERE Fwid=(SELECT Fwid_dol FROM ^work_pers WHERE Fwid="+sqlTo(Number(ID))+")");
			if(snap && snap[0])
				orgID = snap[0];
			ExecuteSQL("DELETE FROM ^stru_dol WHERE Fwid=(SELECT Fwid_dol FROM ^work_pers WHERE Fwid="+sqlTo(Number(ID))+")");
			//удаляем кадровые приказы, т.к. приказ может быть на несколько человек, то сперва чистим людей, а потом удаляем приказы без строк
			ExecuteSQL("DELETE FROM ^prk_in WHERE Fwid_wp="+sqlTo(Number(ID)));
			ExecuteSQL("DELETE FROM ^cdr_prk WHERE  Fdoc="+sqlTo("CDR_IN")+" and not EXISTS(SELECT Fwid_prk FROM ^prk_in as i WHERE i.Fwid_prk=^cdr_prk.Fwid)");
			ExecuteSQL("DELETE FROM ^prk_outin WHERE Fwid_in="+sqlTo(Number(ID)));
			ExecuteSQL("DELETE FROM ^cdr_prk WHERE  Fdoc="+sqlTo("CDR_OI")+" and not EXISTS(SELECT Fwid_prk FROM ^prk_outin as i WHERE i.Fwid_prk=^cdr_prk.Fwid)");
			ExecuteSQL("DELETE FROM ^prk_out WHERE Fwid_wp="+sqlTo(Number(ID)));
			ExecuteSQL("DELETE FROM ^cdr_prk WHERE  Fdoc="+sqlTo("CDR_OUT")+" and not EXISTS(SELECT Fwid_prk FROM ^prk_out as i WHERE i.Fwid_prk=^cdr_prk.Fwid)");
			ExecuteSQL("DELETE FROM ^prk_otp WHERE Fwid_cl="+sqlTo(Number(ftabn_id)));
			ExecuteSQL("DELETE FROM ^cdr_prk WHERE  Fdoc="+sqlTo("CDR_OTP")+" and not EXISTS(SELECT Fwid_prk FROM ^prk_otp as i WHERE i.Fwid_prk=^cdr_prk.Fwid)");
		}
		ExecuteSQL("DELETE FROM ^" + (isGroup ? "stru_org" : "work_pers") + " WHERE fwid=" + sqlTo(Number(ID)));
		if (!isGroup)
		{
			fillGrid(ID);
			if(orgID)
				refreshTreeItem(orgID);
		}
		else
		{
			buildTreeKeysOnTable(treeTbl, 0, 0, "flv1,flv2,flv3,flv4,flv5", "fwid_par");
			Tree.removeAll();
			list.buildTree();
			currentID = "0";
			Tree.setSelected(parID);
			Tree.setExpanded(parID, expanded);
			onTreeSelected(parID);				
		}
	}
	
}

function listMassDel()
{
	if(!confirm(UR(
		"Увага!\nНе вилучайте запис при зміні окладу, посади та іншої інформації про співробітника, натомість проставляйте дату закриття."
			+ "\nВидаляйте запис тільки в тому випадку, якщо вона була введена помилково.\nПродовжити видалення?"
		+ "|Внимание!\nНе удаляйте запись при изменении оклада, должности и другой информации о сотруднике, вместо этого проставляйте дату закрытия."
			+ "\nУдаляйте запись только в том случае, если она была введена ошибочно.\nПродолжить удаление?")))
		return false;
	var strSQLFwids = DataSource().sqlSelected(false);
	var t = OpenTable("SELECT Fwid, Fwid_cl, Fbdat, Fedat FROM ^work_pers WHERE "+strSQLFwids);
	for(;!t.IsEOF(); t.MoveNext())
	{
		var gS = getSnap("SELECT Fvid_prk, Fbdat, Fedat, Fsum, Fin_table, Fwid FROM ^prk_all "
						+" WHERE (Fwid_wp="+sqlTo(t.getValue("Fwid"))
								+" or (Ftabn_id="+sqlTo(t.getValue("Fwid_cl"))+" and (Fwid_wp=0 or Fwid_wp is null)))"
							+" and Fbdat<="+sqlTo(t.getValue("Fedat"))
							+" and Fedat>="+sqlTo(t.getValue("Fbdat")))
		if(gS!=null)
		{
			alert(ru("Нельзя удалить запись, т.к. на таб.№"+getCodFromID(t.getValue("Fwid_cl"))+" существует как минимум 1 приказ \nкод: "
					,"Неможна вилучити запис, томущо на таб.№"+getCodFromID(t.getValue("Fwid_cl"))+" існує як мінімум 1 наказ \nкод: ")+gS[0]
					+ru("\nпериод: ","\nперіод: ")+format("dd.mm.yy",gS[1])+"-"+format("dd.mm.yy",gS[2])
					+ru("\nсумма: ","\nсума: ")+gS[3]+ru("\nтабличная метка: ","\nтаблична мітка: ")+gS[4],ICON_ERROR);
		}
		else
		{
			ExecuteSQL("DELETE FROM ^stru_dol WHERE Fwid IN (SELECT Fwid_dol FROM ^work_pers WHERE Fwid="+sqlTo(t.getValue("Fwid"))+")")
			ExecuteSQL("DELETE FROM ^work_pers WHERE Fwid="+sqlTo(t.getValue("Fwid")));
//			ExecuteSQL("DELETE FROM ^prk_in WHERE Fwid="+sqlTo(t.getValue("Fwid")));
//			ExecuteSQL("DELETE FROM ^prk_outin WHERE Fwid="+sqlTo(t.getValue("Fwid")));
//			ExecuteSQL("DELETE FROM ^prk_out WHERE Fwid="+sqlTo(t.getValue("Fwid")));
		}
	}
	fillGrid();
	refreshTree();
	return true;
}

function groupMenuHandler(sID, ID)
{
	switch(sID)
	{
		case "ADD_PODR":	
			var par = new Object();
			par.disabledED = true;
			par.sMode = "ADD";
			par.fwid = ID;
			var openFile = "e_podr.xml";
			showWindow(openFile, SW_MODAL, par);
			if (!par.escape)
			{
				if (!isEmpty(list.oTblArchG))
				{
					list.oTblArchG.toArchive(par.sMode, getSysName(), toScrObj(par.fwid));
				}

				updateTreeKeys(treeTbl, Number(par.fwid), "flv1, flv2, flv3, flv4, flv5", {parentField: "fwid_par"});
				Tree.removeAll();		
				list.buildTree();				
				//Tree.onSelected(String(par.fwid));
				currentID = -1;
				Tree.onSelected(String(ID));
			}
			break;
		case "EDIT":
			var par = new Object();
			par.sMode = sID;
			par.fwid = Number(ID);
			var openFile = "";
			if (isPodrazd(ID))
				openFile = "e_podr.xml";
			else
				openFile = "e_org.xml";
						
			showWindow(openFile, SW_MODAL, par);			
			if (!par.escape)
			{
				if (!isEmpty(list.oTblArchG))
				{
					list.oTblArchG.toArchive(par.sMode, getSysName(), toScrObj(ID));
				}
				
				if (par.refill)
				{					
					Tree.removeAll();
					list.buildTree();
					var sID =  currentID;	
					currentID = "0";
					Tree.setSelected(sID);
					onTreeSelected(sID, ID);					
				}	
				else
				{
					refreshTreeItem(ID);
					fillGrid(ID);
				}
			}
			break;
		case "LIKV":
			var isPodr = isPodrazd(ID);
			if (isPodr)
			{
				var isAllSubLikv = true;
				var snap = getSnap("SELECT COUNT(*) FROM ^stru_dol "
					+ " WHERE fwid_org=" + sqlTo(Number(ID)) + " AND fedat=" + SqlMaxDate + " AND fcod<>0");
				if (snap[0] > 0)
					isAllSubLikv = false;
				if (isAllSubLikv)
				{
					/*snap = getSnap("SELECT COUNT(*) FROM ^stru_org AS org "
						+ " LEFT JOIN ^stru_dol AS dol ON org.fwid=dol.fwid_org "
							+ " LEFT JOIN ^work_pers AS wp ON dol.fwid=wp.fwid_dol "
						+ " WHERE org.fwid=" + sqlTo(Number(ID))
							+ " AND dol.fedat=" + SqlMaxDate
							+ " AND wp.fedat=" + SqlMaxDate);
					if (snap[0] > 0)
						isAllSubLikv = false;*/
				}
				if (!isAllSubLikv)
				{
				 	alert(ru(
				 		"В этом подразделении есть неликвидированные подразделения или должности.\nЛиквидируйте сначала их.", 
               			"В цьому підрозділі є неліквідовані підрозділи або посади.\nЛіквідуйте спочатку їх."),
	               		ICON_WARNING);
	            	return;
				}				
			}
			var par = new Object();
			par.sMode = sID;
			par.fwid = Number(ID);
			var openFile = "";
			if (isPodr)
				openFile = "e_podr.xml";
			else
				openFile = "e_org.xml";								
			showWindow(openFile, SW_MODAL, par);
			if (!par.escape)
			{
				if (!isEmpty(list.oTblArchG))
				{
					list.oTblArchG.toArchive(par.sMode, getSysName(), toScrObj(ID));
				}
				
				Tree.removeAll();
				list.buildTree();
				var sID =  currentID;	
				currentID = "0";
				Tree.setSelected(sID);
				onTreeSelected(sID, ID);
			}
		break;
		case "PRINT_PODR":
			var snap = getSnap("select Fleftkey, Frightkey from "+workTable+" where Fwid="+ID)
			if(!snap)
			{
				alert(ru("Не найдено подразделение с идетификатором ","Не знайдено підрозділ з ідентифікатором ")+ID);
				return false;
			}
			var fleft = snap[0];
			var fright = snap[1];
			include("Objects/DpTvars.js");
			var tv = new DpTVars("SHTATPODR");
			DropTable("prn_shtat");
			ExecuteSQL("select MIN(Foklad) as Fminoklad, MAX(Foklad) as Fmaxoklad, COUNT(Fwid) as Fkoldol, Fcoddol, "
							+" Fleftkey, Frightkey, 0 as Fnum "
					+" into prn_shtat "
					+" from "+workTable
					+" where Fleftkey>="+fleft+" and Frightkey<="+fright+" and Fident="+sqlFalse
					+" group by Fleftkey, Frightkey, Fcoddol");
			ExecuteSQL("alter table prn_shtat add column Fdol "+ sqlType("TEXT", 255));
			ExecuteSQL("alter table prn_shtat add column Fpodr "+ sqlType("TEXT", 255));
			ExecuteSQL("update prn_shtat set Fdol=(select distinct Fpos from "+workTable+" as w "
							+" where w.Fleftkey=prn_shtat.Fleftkey and w.Frightkey=prn_shtat.Frightkey and w.Fcoddol=prn_shtat.Fcoddol)");
			ExecuteSQL("update prn_shtat set Fpodr=(select Ftxt from "+workTable+" as w "
							+" where w.Fleftkey=prn_shtat.Fleftkey and w.Frightkey=prn_shtat.Frightkey and w.Fident="+sqlTrue+")");
			DropTable("tmp_prn_shtat");
			ExecuteSQL("select * into tmp_prn_shtat from prn_shtat");
			//обновляем признак на фильтр в печати для первых должностей в каждом подрзаделении
			ExecuteSQL("update prn_shtat set Fnum=1 where exists(select p2.Fcoddol from tmp_prn_shtat as p2 "
					+" where p2.Fleftkey=prn_shtat.Fleftkey group by p2.Fleftkey having min(p2.Fcoddol)=prn_shtat.Fcoddol )");
			var tPrn = OpenTable("select * from prn_shtat order by Fleftkey,Fcoddol ");
			tv.setRTbl(tPrn);
			var h = new Object();
			h.BDAT = bdat;
			h.EDAT = edat;
			tv.setHTbl(h);
			tv.print();
			tPrn.close();
		break;
	}
}

var persMenuHandler = personalMenuHandler;

function personalMenuHandler(sID, toObject, ID)
{
	var xmlForm;
	var par = new Object();			
	par.param = new Object();
	par.param.fwid_podr = Number(ID);
	par.param.bdat = bdat;
	par.param.edat = edat;
	var prk = null;
	var mode = "ADD";
	var ID = Number(grid.table.getValue("fwid"));
trace("TRACE SHTAT_MODE : "+sID)
	var orgID = 0;
	switch(sID)
	{
		case "ADDP"://назначение		
			//prk = new DpDoc("com.debet.cdr.in", 0);
			xmlForm = "e_prk_zrp_in.xml";
			par.mode = "ADD";
			orgID = par.param.fwid_podr;
			break;
		case "MASS_ADDP"://массовое назначение		
			xmlForm = "e_prk_zrp_in.xml";
			par.mode = "MASS_ADD";
			orgID = par.param.fwid_podr;
			break;
		case "MOVEP":
			//prk = new DpDoc("com.debet.cdr.oi", 0);
			xmlForm = "e_prk_zrp_oi.xml";
			par.param.fwid_out = ID;
			par.param.fwid_dol = Number(grid.table.getValue("fwid_dol"));
			par.param.tabnorg = Number(grid.table.getValue("ftabnorg"));
			//указываем режим копирования, чтоб инициализировались расширения
			par.mode = "COPY";
			break;
		case "MOVEPODR":
			var parOrg = new Object();
			parOrg.escape = true;
			parOrg.dat1 = bdat;
			parOrg.dat2 = edat;
			parOrg.fwid = par.param.fwid_podr;
			showWindow("e_stru_org.xml", SW_MODAL, parOrg);
			if (!parOrg.escape)
			{
				var l = new Object();
				l.FWID = grid.table.getValue("fwid_dol");
				l.FWID_ORG = parOrg.fwid;
				UpdateTable("^stru_dol", l, false);		
				grid.table.requery();
				refreshGrid(ID);
			}
			return;
			break;
		case "DELP"://увольнение
			//prk = new DpDoc("com.debet.cdr.out", 0);
			xmlForm = "e_prk_zrp_out.xml";
			par.param.fwid = ID;
			//par.param.fwid_dol = Number(grid.table.getValue("fwid_dol"));
			par.mode = "EDIT";
			break;
		case "EDIT_I"://редактировать назначение
			//prk = new DpDoc("com.debet.cdr.in", 0);
			//prk.loadByID(ID);
			xmlForm = "e_prk_zrp_in.xml";
			par.param.fwid = ID;
			par.param.fid = Number(grid.table.getValue("fid"));
			par.mode = "EDIT";
			//par.param.disableDol = true;
			//par.param.disablePriem = true;
			break;
		case "EDIT_O":
			//prk = new DpDoc("com.debet.cdr.out", 0);
			//par.param.fwid = ID;
			//mode = "EDIT";
			break;
		case "EDIT_LIC_CART":
			var oPar = new Object();		
			
			//oPar.Fvid = 3;
			oPar.tbl = grid.table;
			
			include ("objects/DpClEx.js")
			var oCL = null; 
			
			oCL = new DpClEx("CL3", codPers);
			oCL.setFormFile("formpf");
			
			var ret = false;
			var tabn_id = Number(grid.table.getValue("ftabn_id"));
				ret = oCL.edit("EDIT",tabn_id, oPar);			
			
			if(ret)
			{
				grid.table.requery();
				//this.tbl.findByID(oCL.getID());
				//grid.refresh();	
				refreshGrid(ID);
			}		
			return;			
			break;
		default:
//			if (sID.substring(0, 7).toUpperCase() == "EDIT_OI")
//			{
//				prk = new DpDoc("com.debet.cdr.oi", 0);
//				var field = String(toObject.getData("field" + sID.substring(sID.lastIndexOf("_") + 1)));
//				if (field != "")
//				{
//					var snap = getSnap("SELECT fwid FROM ^prk_outin WHERE "
//										+ field + "=" + sqlTo(toObject.table.getValue("fwid")));
//					if (snap != null)
//					{
//						ID = snap[0];
//						mode = "EDIT";
//						break;
//					}				
//				}
//				prk = null;
//			}
			break;
	}
	/*if (prk != null)
	{		
		prk.setFormFile("formzrp");
		prk.edit(mode, ID, par);
		if (!par.escape)
			refreshGrid(ID);
	}*/
	if(xmlForm)
	{
		if(sID!="DELP")
		{
			par.ExtAliases = "#";
			par.tblSrc = grid.getTable();
		}
		showWindow(xmlForm, SW_MODAL, par);
		if (!par.escape)
		{
			if (!isEmpty(list.oTblArch))
			{
				var id_work = inList(par.mode, "ADD", "COPY") ? par.fwid : ID;
				var id_dol = getSnap("SELECT FWID_DOL FROM ^WORK_PERS WHERE FWID = "+id_work)[0];
				list.oTblArch.toArchive(par.mode, getSysName(), id_work, "^WORK_PERS");
				list.oTblArch.toArchive(par.mode, getSysName(), id_dol, "^STRU_DOL");
			}
			
			refreshGrid(sID=="MOVEP" && par.new_fwid?par.new_fwid:ID);
			if(orgID)
				refreshTreeItem(orgID);
		}
	}
}

function refreshGrid(gridID, selection)
{
	requaryTable();
				
	var absolute = 1;
	if (table != null)
		absolute = table.getAbsolute();
	var sSQL = "SELECT * FROM " + workTable
			+ (!useFast? "" : " WHERE FWID=" + sqlID + " OR (fleftkey BETWEEN " + sqlLeftKey + " AND " + sqlRightKey + ")")
			+ " ORDER BY fleftkey, fident DESC, fcoddol, fcod, fid, fbdat, fedat";
	if(table!=null)
	{
		table.setScriptEngine(Task.getScriptEngine());
		table.requery(/*sSQL*/);
	}
	else
		table = OpenTable(sSQL);  
	/*
	if(arrSelID.length>0)
	{
		var sFwid = "0";
		for(var i=0; i<arrSelID.length; i++)
			sFwid += ","+ arrSelID[i];
		table.openSel(" FWID in ("+ sFwid +")");		
	}	 
	grid.setTable(table);
	if(arrSelID.length>0)
		grid.setSelectedIDs(arrSelID);		
	*/
	if (typeof selection != "undefined")
	{
		table.setAbsolute(Number(selection))
	}
	else if (typeof gridID != "undefined")	
	{
		if (!table.findByID(Number(gridID)))
		{
			if (absolute <= table.getRecordCount() + 1)
				table.setAbsolute(absolute);
		}		
	}
	else if (absolute <= table.getRecordCount() + 1)
	{
		table.setAbsolute(absolute);
	}		
	list.tbl = table;
	if(getPar("ZRP_SST") && extSstTblName)
	{
		table.clTie("CL_EXT","="+getPar("ZRP_SST")+",FCOD_SST");
		table.tie(extSstTblName, "EXT_SST", "Fmainwid", "CL_EXT.Fwid");
	}
//	пока функция DeleteExtPages не реализована, поэтому при редактировании записей притаиные текстовки будут исчезать
//	grid.DeleteExtPages();
//	grid.addExtPage();
	grid.refresh();
}

function isPodrazd(ID)
{
	snap = getSnap("SELECT fwid_par FROM ^stru_org WHERE fwid="	+ sqlTo(Number(ID)));	
	return  (snap != null && snap[0] != null && snap[0] != 0);
}

function getCountOrganization()
{	
	var snap = getSnap("SELECT COUNT(*) FROM " + treeTbl + " WHERE fwid_par IS NULL "
						+ " AND flv1=0 AND flv2=0 AND flv3=0 AND flv4=0 AND flv5=0");
	if (snap == null)
		return false;
	if (snap[0] > 0)
	{
		if ("y" == msgBox("&yn", UR("1|1"), UR("2|2")))
		{
			ExecuteSQL("UPDATE " + treeTbl + " SET fwid_par=0 WHERE fwid_par IS NULL "
					+ " AND flv1=0 AND flv2=0 AND flv3=0 AND flv4=0 AND flv5=0");
		}
	}
	return getSnap("SELECT COUNT(*) FROM " + treeTbl + " WHERE fwid_par=0")[0];
}

function isAccessOnRun()
{
	var countOrg = getCountOrganization();
	if (countOrg > 1)
	{
		alert(UR("ERROR DATA"), ICON_ERROR);
		return false;
	}
	if (countOrg <= 0)
	{
		var txt = UR("Ваша організація|Ваша организация");
		var fwid = GetUID();
		if (!ExecuteSQL("INSERT INTO " + treeTbl + " (fwid, fwid_par, ftxt, ftxts, fbdat, fedat ) values(" + sqlTo(fwid)
				+ ",0," + sqlTo(txt) + "," + sqlTo(txt) + "," + sqlTo(d00min) + "," + sqlTo(d00) + ")"))
		{
			alert(UR("CREATE ORG ERROR"), ICON_ERROR);
			return false;
		}
		buildTreeKeysOnTable(treeTbl, 0, 0, "flv1,flv2,flv3,flv4,flv5", "fwid_par");
		return true;
		
	}
	return true;	
}

function createTmpTable(tblName)
{
	var sql = "CREATE TABLE " + tblName + " ("
			+ "fwid " + SqlType("long")
			+ ",ftabn_id " + SqlType("long")
			+ ",fwid_dol " + SqlType("long")
			+ ",fbdat " + SqlType("date")
			+ ",fedat " + SqlType("date")
			+ ",fwrkdat " + SqlType("date")
			+ ",fvopl " + SqlType("int")
			+ ",ftxt " + SqlType("text")
			+ ",fcod " + SqlType("int")
			+ ",fpos " + SqlType("text")
			+ ",fident" + SqlType("bit")
			+ ",fleftkey " + SqlType("long")
			+ ",frightkey " + SqlType("long")
			+ ",foklad " + SqlType("currency")
			+ ",fcoddol " + SqlType("long")
			+ ",finval " + SqlType("bit")
			+ ",fshpz " + SqlType("text")
			+ ",fid " + SqlType("short")
			+ ",favans " + SqlType("currency")
			+ ",fkodkat " + SqlType("long")
			+ ",fkodzvan " + SqlType("long")
			+ ",fis_serv " + SqlType("bit")
			+ ",fis_uv " + SqlType("bit")
			+ ",fis_nazn " + SqlType("bit")
			+ ",fnewrm " + SqlType("byte")			
			+ ",ftable " + SqlType("long")
			+ ",fcalend " + SqlType("short")
			+ ",fkod_uv " + SqlType("short")
			+ ",fismain " + SqlType("bit")
			+ ",fpens " + SqlType("bit")
			+ ",fcod_ssv " + SqlType("long")
			+ ",fcod_kzo " + SqlType("long")
			+ ",fcod_sst " + SqlType("long")
			+ ",ftabnorg " + SqlType("long")
			+ ",fkolst " + SqlType("currency")
			+ ",fsex " + SqlType("bit")
			+ ",fpodr " + SqlType("long")
			+ ",findnum " + SqlType("text")
			+ ",FDOCSER " + SqlType("text")
			+ ",FDOCNOM " + SqlType("text")
			+ ",FDOCOWN " + SqlType("text")
			+ ",FDOCDAT " + SqlType("date")
			+ ",FPIDROZD " + SqlType("text")															
			+ ",FTXTKAT " + SqlType("text")
			+ ",fwidOrg_I " + SqlType("long")
			+ ")";
	return ExecuteSQL(sql);
}




function checkHandler(id, isCheck)
{	
	var snap = getSnap("SELECT fwid FROM ^stru_org WHERE fwid=" + sqlTo(Number(id)));
	if (snap != null)
		return false;
	arraySelectedIDs[String(id)] = toScrObj(isCheck);
	return isCheck;
}

function onSave()
{
	extPar.escape = false;	
	extPar.ret = new Array();
	extPar.ftabn_id = new Array();
	var i = 0;
	var t = OpenTable("s", "SELECT Fwid,Fwid_cl FROM ^work_pers WHERE "+DataSource().sqlSelected());
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		extPar.ftabn_id[i] = Number(t.getValue("Fwid_cl"));
		extPar.ret[i++] = Number(t.getValue("Fwid")); 
	}
	t.close();
	/*var i = 0;
	for (var id in arraySelectedIDs)
		if (arraySelectedIDs[id] == true)
			extPar.ret[i++] = Number(id);*/
	CloseWindow();
}

function onEscape()
{
	extPar.escape = true;
	CloseWindow();
}

function listCanSortField(sFld)
{
	//запрещаем сортировку для всех полей
	return false;
}

function getLvls(Flv1,Flv2,Flv3,Flv4,Flv5)
{
	return String(Flv1)+(!isEmpty(Flv2)?("/"+Flv2+(!isEmpty(Flv3)?("/"+Flv3+(!isEmpty(Flv4)?"/"+Flv4+(!isEmpty(Flv5)?"/"+Flv5:""):"")):"")):"");
}

function getSexTxt(fsex)
{
	if(toScrObj(fsex))
		return UR("ч|м");
	else
		return "ж";
}

function listTblArchive()
{
	//объект для архивации изменений по человеку
	this.oTblArch = new DpTblArchive();
	this.oTblArch.setList(this, false);
	this.oTblArch.addTbl("^WORK_PERS");
	this.oTblArch.addTbl("^STRU_DOL", "", "FWID_DOL");
	
	//объект для архивации изменений по подразделению
	this.oTblArchG = new DpTblArchive();
	this.oTblArchG.setList(this, false);
	this.oTblArchG.addTbl("^STRU_ORG");
}

include("sys/DpList.js");