//назначение и редактирование для ШР, переделан из документа com.debet.cdr.in
include("Objects/DpCl.js");
include("Objects/DpClEx.js");
include("Objects/DpVopl.js");
include("Objects/DpShifPZ.js");
include("Objects/DpPost.js");
include("servis/format.js");
include("servis/date.js");
include("sys/udfs.js");

//var obj = extPar.doc; 
var param = extPar.param;
var lowDat = null;
var tmpLowDat = null;
//var ctrlLinker = null;
var dpPers,dpDol,dpVopl,dpKodKat,dpKodZvan,oldDol,dpShifPZ,dpSSV,dpKZO,dpSST;

var codDol = 0;
var codPers = 0;
var codKat = 0;
var codZvan = 0;
var codorg;

var fwid_dol=fwid_cl=fwid_kat=fwid_zvan=0;
var fvopl, fwid_dol_old, txt, isNewPost;
var isnew = false;
var mode = extPar.mode;
var ISNEWDOL = true;
var editVakansMode = false;
var bdatLoad,codDisMotive,oStatUv;
var dpSSV, dpKZO, dpSST;

function Load() 
{
   	switch(mode)
   	{
   		case "MASS_ADD":
   			txt = UR("(масове додавання)|(массовое добавление)");
   		break;
   		case "EDIT":
   			txt = UR("(редагування)|(редактирование)");
   		break
   		default:
   			txt = "";
   	}
   	
   	Caption(UR("Наказ: призначення на посаду |Приказ: назначение на должность ")+txt);
   	/*//реализована возможность ручной простановки fwid-а в work_pers
   	//при назначении на должность, сделано с целью востановления целосности данных 
   	//при случайном удалении записи из штатного расписания, которая уже была 
   	//связана с приказами, табелями или лицевыми счетами
   	if(mode == "ADD")
   	{
   		Enable(RESTORE);
   		Disable(FWID_WP);
   	}
   	else
   	{
   		Disable(RESTORE);
   		Disable(FWID_WP);
   	}
   	setValid(RESTORE,restore_Valid);
   	setValid(FWID_WP,fwid_wp_Valid);
   	FWID_WP.setMask("######");*/
   	
   	RTERM.setMask("##");
   	RREASON.setMask(strRepl("&", 255));
   	RKOLST.setMask("######.##");
   	ROKLAD.setMask("######.##");
   	RAVANS.setMask("######.##");
   	RFIKSSUM.setMask("######.##");
   	RPREWOKL.setMask("######.##");   	
   	//RTABLE.setMask("#");
   	init_RTABLE();
   	
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_PERSONAL != "undefined")
		codPers = getPar(const_GETPAR_PERSONAL);
	else
		codPers = getPar("CODPERS");
	dpPers = new DpCl("", codPers, 0);
	dpPers.linkCtrl(RTABN, RTABNTXT);
	dpPers.addCondition("condition");
	
	if(getPar("TABNORG"))
   	{
   		//определяем код подразделения к которому потом будем прибавлять свободный номер
   		var snap = getSnap("select Flv1,Flv2,Flv3,Flv4 from ^stru_org where Fwid="+param.fwid_podr);
		if(snap && snap[0])
			codorg = String(snap[0])+(snap[1]!=0?(snap[1]+(snap[2]!=0?(snap[2]+(snap[3]!=0?snap[3]:"")):"")):"");
   		else
		{
			alert(ru("Ошибка в иерархии подразделений!","Помилка в ієрархії підрозділів!"));
			return false;
		}
   		GRTABNORG.visible = true;
   		if(mode=="EDIT" || mode=="MASS_ADD")
   			Disable(RTABNORG);
   		else
   		{
   			RTABNORG.value = getNextTabnOrg(param.fwid_podr);
   			//устанавливаем код по умолчанию при добавлении сотрудника в справочнике
   			dpPers.setDefCod(Number(RTABNORG.value));
   			//пока в МВД счетчики не синхронизированы навесим валидность, потом RTABNORG задизейблим и номера будут назначаться автоматом  
   			setValid(RTABNORG,tabnorgValid);
   			setFocus(RTABNORG);
   		}
   		RTABNORG.setMask("##############");
   	}
   	else
   	{
   		GRTABNORG.visible = false;
   	}
	
	if(mode == "MASS_ADD")
	{
		RTABN.enabled = false;
		RTABNTXT.enabled = false;
		Disable(RUVOL);	
	}

	dpVopl = new DpVopl();
	dpVopl.linkCtrl(RVOPL, RVOPLTXT);
	
	//для совместимости с диллерским модулем кадрового планирования CDRP
	//из-за этого номер справочника категорий нужно прописать в параметрах в учете кадров в кадровом планировании
	//параметр "номер довідника видів посад, чтобы в штатном расписании не двоились записи при добавлении сотрудника прямо из
	//зарплаты из штатного расписания без системы кадров
	if(typeof const_GETPAR_VIDPOSAD != "undefined")
		codKat = getPar(const_GETPAR_VIDPOSAD);
	else
		codKat = getPar("CODKAT","ZRP");
	
	dpKodKat = new DpCl("", codKat, 0);
	dpKodKat.linkCtrl(RKODKAT, RKODKATTXT);
//	if(mode == "EDIT")
//		Disable(RKODKAT);
	
	codZvan = getPar("CODZVAN");
	dpKodZvan = new DpCl("0", codZvan, 0);
	dpKodZvan.linkCtrl(RKODZVAN, RKODZVANTXT);
	if(!codZvan)
		Disable(RKODZVAN);
	
   	dpShifPZ = new DpShifPZ();
	dpShifPZ.setUseZiro(true);
	dpShifPZ.linkCtrl(RSHPZ, RSHPZ_TXT);
	if(mode == "ADD" || mode == "MASS_ADD")
	{
		dpShifPZ.setFshpz(0);
		RISMAIN.value = true;
	}
   	
   	codDol = getPar("CODDOL","ZRP");
	dpDol = new DpPost(mode, ISNEWDOL == true);
	dpDol.linkCtrl("fcod", FCOD);
	dpDol.linkCtrl("dol_ftxt", FTXT, true);
	dpDol.linkCtrl("foklad", ROKLAD);
	dpDol.linkCtrl("fshpz", dpShifPZ);
	dpDol.setFWID_ORG(param.fwid_podr);


	setValid(FCOD, FCODDOL_valid);
	
	codSSV = getPar("ZRP_SSV");
	//dpSSV = new DpCl("0", codSSV, 0);
	dpSSV = new DpCl("", codSSV, 0);
	dpSSV.linkCtrl(FCOD_SSV, FTXT_SSV);
	
	codKZO = getPar("ZRP_KZO");
	//dpKZO = new DpCl("0", codKZO, 0);
	dpKZO = new DpCl("", codKZO, 0);
	dpKZO.linkCtrl(FCOD_KZO, FTXT_KZO);
	
	codSST = getPar("ZRP_SST");
	dpSST = new DpCl("0", codSST, 0);
	dpSST.linkCtrl(FCOD_SST, FTXT_SST);
	dpSST.linkExtCtrl("CODOSN",FCODOSN);
	
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_DISMOTIVE != "undefined")
		codDisMotive = getPar(const_GETPAR_DISMOTIVE);
	else
		codDisMotive = getPar("CDRSTATUV");
	if(!codDisMotive)
		alert(ru("Не установлен параметр в меню: ","Не встановлено параметр в меню: ")
				+getParItemPath(typeof const_GETPAR_DISMOTIVE != "undefined"?const_GETPAR_DISMOTIVE:"CDRSTATUV",true),1);
	oStatUv = new DpCl("0", codDisMotive, 0);
	oStatUv.linkCtrl(RREASON_ST, RREASON_ST_TXT);
	if(!codDisMotive)
		Disable(RREASON_ST);
	
   	if(mode == "EDIT")
   	{
		RKODKAT.value = 0;   		
   		var tbl = OpenTable("SELECT * FROM ^work_pers "
   						+" WHERE Fwid="+sqlTo(param.fwid))
   		if(tbl.rowCount>0)
   		{
			RBDAT.value = tbl.getValue("Fbdat");
			bdatLoad = tbl.getValue("Fbdat");
   			REDAT.value = tbl.getValue("Fedat");
   			RNAZN.value = (tbl.getValue("Fnazn")==1)?true:false;
   			RNEWRM.value = Number( tbl.getValue("Fnewrm"));
   			RDTNEWRM.value = tbl.getValue("Fdtnewrm")   			
   			RUVOL.value = tbl.getValue("Fis_uv")==1?true:false;
   			RZAPIS.value = tbl.getValue("Fis_serv")==1?true:false;
   			RPRIEM.value = tbl.getValue("Fis_nazn")==1?true:false;
   			RTABLE.value = Number(tbl.getValue("Ftable"));
   			fwid_dol = Number(tbl.getValue("Fwid_dol"));
   			fwid_cl = Number(tbl.getValue("Fwid_cl"));
   			fwid_kat = Number(tbl.getValue("Fwid_kat"));
			dpKodKat.setFWID(fwid_kat);
   			fwid_zvan = Number(tbl.getValue("Fwid_zvan"));
   			fvopl = tbl.getValue("Fvopl");
   			RAVANS.value = tbl.getValue("Favans");
   			RINVAL.value = tbl.getValue("Finval")==1?true:false;
   			RTERM.value = tbl.getValue("Fterm");
   			RREASON.value = tbl.getValue("Freason");
			RKOD_UV.value = toScrObj(tbl.getValue("Fkod_uv"));
   			RPENS.value = tbl.getValue("Fpens")==1?true:false;
   			RREASON_UV.value = tbl.getValue("Freason_uv");
   			oStatUv.setCod(tbl.getValue("Freason_uvst"));
   			dpSSV.setCod(tbl.getValue("Fcod_ssv"));
   			dpKZO.setCod(tbl.getValue("Fcod_kzo"));
   			dpSST.setCod(tbl.getValue("Fcod_sst"));
   			RTABNORG.value = tbl.getValue("Ftabnorg");
			RISMAIN.value = tbl.getValue("FISMAIN")==1?true:false;
			RKOLST.value = tbl.getValue("FKOLST");
   			RTRSOG.value = tbl.getValue("FISTRSOG")==1?true:false;
   			RBASEMIND.value = tbl.getValue("Fbasemind");
   			RFIKSSUM.value = tbl.getValue("FFIKSSUM");
   			RPREWOKL.value = tbl.getValue("FPREWOKL");
   		}
   		tbl.close();
   		
   		if(Number(fwid_cl)>0)
   			RTABN.enabled = false;
   		else
   		{//режим редактирование вакансии
   			editVakansMode = true;
   			dpPers.setMode("0");
   		}
   		
   		dpDol.setDate(RBDAT.getValue());
   		if(fwid_dol>0)
   		{
			dpDol.setFWID_DOL(fwid_dol);
			fwid_dol_old = fwid_dol;
   		}	
   		if(fwid_cl>0)
   			dpPers.setFWID(fwid_cl);
		if(fvopl>0)
			dpVopl.setVopl(fvopl);
		//SAM 03.08.2010
		//Здесь что-то перемудровали.
		//Всё нужное делается на этапе валидации кода должности FCODDOL_valid
		//>>> Tori 27.08.2010 эта инициализация fwid-а должна происходить только раз при загрузке, а не при каждом вызове валидности
		if(fwid_kat>0 && typeof const_GETPAR_VIDPOSAD == "undefined")
		{
			dpKodKat.setFWID(fwid_kat);
		}
		else
		{
			//05.02.13 Яна У меня этот оператор перебивал код категории. Может, это только у меня???
			//RKODKAT.value = 0;
		}
		if(fwid_zvan>0)
			dpKodZvan.setFWID(fwid_zvan);
		else
			RKODZVAN.value = 0;
		if(fwid_dol>0)
			setLowDate(fwid_dol);
   	}
   	else
   	{
   		RBDAT.value = d00;
   		REDAT.value = d00;
   		RTERM.value = 0;
   		RAVANS.value = 0;
   		RPRIEM.value = true;
   		RTABLE.value = 1;
   		RKOLST.value = 1;
   		RFIKSSUM.value = 0;
   		RPREWOKL.value = 0;   		
   		RBASEMIND.value = d00;   		
   	}

	ISNEWDOL = mode != "EDIT";
	checkValid();

	if (RTABLE.value==1 && RTRSOG.value==false){	
		Disable(RTRSOG);
	}else{
		Enable(RTRSOG);		
	}	
	
	setValid(RBDAT, bdatValid);
	setValid(REDAT, edatValid);
	//setValid(NEWDOL, checkValid);
	setValid(RPRIEM, priemValid);
	setValid(RUVOL, uvolValid)
	setValid(RTABLE, RTABLE_valid);
	
	priemValid();
	uvolValid();
	if(mode == "ADD")
	{
		setValid(ISVAKANS,isvakansValid);
		isvakansValid();
		if(!getPar("VAKANS"))
			Disable(ISVAKANS);
	}
	else
		Disable(ISVAKANS);
		
	setValid(FCOD, fcod_Valid);
	setValid(RTABN, tabn_Valid)
//	if(param.disableDol)
//		Disable(NEWDOL);
	if(param.disablePriem)
		Disable(RPRIEM);
	//при редактировании валидность табельного номера вызываем отдельно, т.к. он неактивен
	if(mode == "EDIT")
		tabn_Valid();
	//инициализация контролов для импорта сотрудников из другой базы
   	if(extPar.tblPref)
   	{
   		var t = OpenTable(s="SELECT * FROM "+extPar.tblPref+"full_pers "
   						+" WHERE Fwid_cl="+sqlTo(param.fwid_old)+" and Fedat="+sqlTo(d00));
   		if(t.rowCount != 0)
   		{
			RBDAT.value = today.getVarDate();
			bdatLoad = RBDAT.value;
   			REDAT.value = d00;
   			RNAZN.value = t.getValue("Fnazn");
   			RNEWRM.value = Number(t.getValue("Fnewrm"));
   			RDTNEWRM.value = t.getValue("Fdtnewrm");   			
   			RUVOL.value = t.getValue("Fis_uv");
   			RZAPIS.value = t.getValue("Fis_serv");
   			RPRIEM.value = t.getValue("Fis_nazn");
   			RTABLE.value = Number(t.getValue("Ftable"));
   			fwid_dol = 0;
   			fwid_cl = param.fwid_new;
   			fwid_kat = 0;
   			fwid_zvan = 0;
   			fvopl = t.getValue("Fvopl");
   			RAVANS.value = t.getValue("Favans");
   			ROKLAD.value = t.getValue("Foklad");
   			RINVAL.value = t.getValue("Finval");
   			RTERM.value = t.getValue("Fterm");
   			RREASON.value = t.getValue("Freason");
   			RKOD_UV.value = toScrObj(t.getValue("Fkod_uv"));
   			RPENS.value = t.getValue("Fpens");
   			RREASON_UV.value = t.getValue("Freason_uv");
   			oStatUv.setCod(tbl.getValue("Freason_uvst"));
   			dpKodKat.setCod(t.getValue("Fcodkat"));
   			dpKodZvan.setCod(t.getValue("Fcodzvan"));
   			var oDol = new DpCl("", getPar("CODDOL"), 0);
   			oDol.linkCtrl(FCOD,FTXT);
   			oDol.setCod(t.getValue("Fcoddol"));
   			dpShifPZ.setFshpz(t.getValue("Fshpz"));
   			dpPers.setFWID(fwid_cl);
   			dpVopl.setVopl(fvopl);
   			dpSSV.setCod(t.getValue("Fcod_ssv"));
   			dpKZO.setCod(t.getValue("Fcod_kzo"));
   			dpSST.setCod(t.getValue("Fcod_sst"));
			RISMAIN.value = t.getValue("FISMAIN");
			RKOLST.value = t.getValue("FKOLST");
			RTRSOG.value = t.getValue("FISTRSOG");
   			RFIKSSUM.value = t.getValue("Ffikssum");
   			RBASEMIND.value = t.getValue("FBASEMIND");
   			RPREWOKL.value = t.getValue("Fprewokl");   			
   		}
   		t.close();
		t = null;
		RTABN.enabled = false;
   	}
   	setValid(RINVAL,invalValid);
	FCODDOL_valid();
}

function FCODDOL_valid()
{
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_VIDPOSAD != "undefined")
		dpKodKat.setFWID(getKodKatFwid(dpDol.getCod()));
}

function RTABLE_valid()
{
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if (RTABLE.value!=1){
		Enable(RTRSOG)
	}else{
		if (RTABLE.value==1){
			RTRSOG.value=false;			
			Disable(RTRSOG);
		}	
	}
}

function onSave()
{
	/*if (mode == "EDIT" && dpDol.getFWID() == oldDol && NEWDOL.value == false)
	{
		fwid_dol = obj.getVar("RWID_DOL");
		var edat = getSnap("SELECT fedat FROM ^work_pers WHERE fwid=" + sqlTo(obj.getVar("RWID_WP")))[0];
		if (differ(toScriptDate(d00), toScriptDate(edat)) == 1
			&& differ(toScriptDate(RBDAT.value), toScriptDate(edat)) == 1)
		{
			WAIT(UR("Дата наказу не може бути більша |Дата приказа не может быть больше ") + StrDat(edat, "DMY"));
			setFocus(RBDAT);
			return false;
		}
	}
	else
	{
		fwid_dol = findFreeDol();
		if (fwid_dol == null)
			return false;
	}*/
	//для импорта сотрудников из другой базы нужно знать дату назначение, чтоб днем раньше уволить их в ШР базы-источника
	extPar.bdat = RBDAT.value;
	if(mode == "MASS_ADD")
	{
		var par = new Object();
		par.Fcl = codPers
		par.ret = new Object;
		par.ret.fwid = null;
		if(!extPar.retArray)
			showWindow("l_cl.xml",SW_MODAL,par)
		else
			par.retArray = extPar.retArray;
		if (!par.escape || extPar.retArray)
        {
        	//если выбрали только одну запись, то делаем обычное назначение
        	if(par.retArray.length==0)
        	{
				dpPers.setFWID(par.ret.fwid);
        	}
        	else
        	{
				//каждого отмеченного сотрудника на новую должность
				isNewPost = true;
				setProgressRange(1, par.retArray.length);
				for(var i=0; i<par.retArray.length; i++)
				{
					setProgressPos(i+1, ru("Массовое назначение в ШР ","Масове назначення в ШР ")+(i+1)+"/"+par.retArray.length);
					for(var j in par.retArray[i])
					{
						if(j=="fwid")
						{
	                		if(!savePers(GetUID(),par.retArray[i][j],RBDAT.value,REDAT.value))
	                		{
	                			setProgressPos(0);
	                			return false;
	                		}
						}
					}
				}
				setProgressPos(0);
				return true;
        	}
        }
	}
	if (!validAvans())
		return false;
	
	fwid_dol = dpDol.getFWID_DOL(); 
	isNewPost = false;
	if (fwid_dol == -1)
	{
		isNewPost = true;
		fwid_dol = GetUID();
	}
	if(fwid_dol!=fwid_dol_old && mode=="EDIT")
	{
		if(confirm(ru("Должность была изменена!\nЭта операция допустима только при ошибочном вводе должности." +
					"\nВ остальных случаях необходимо переводить человека используя соответствующий пункт меню." +
					"\nПродолжить сохранение записи?",
						"Посада була змінена!\nЦя операція допустима лише при помилковому введенні посади.\n" +
					"В інших випадках необхідно переводити людину використовуючи відповідний пункт меню." +
					"\nПродовжити збереження запису?")))
		{
			//удаляем из stru_dol старую запись
			ExecuteSQL("delete from ^stru_dol where fwid="+fwid_dol_old)
		}
		else
		{
			//востанавливаем старую должность
			var snap = getSnap("select Fcoddol from ^full_pers where Fwid_dol="+fwid_dol_old);
			if(snap)
			{
				dpDol.setCod(snap[0]);
				ISNEWDOL = false;
				checkValid();
				fwid_dol_old = dpDol.getFWID_DOL();
			}
			return false;
		}
	}
	//если режим редактирования вакансии, то при назначении сотрудника, вакансию закрываем днем раньше
	if(editVakansMode)
	{
		if(differ(bdatLoad,RBDAT.value)==0 && dpPers.getCod()>0)
		{
			if(!confirm(ru("Дата принятия на работу сотрудника совпадает с датой открытия вакансии!\nПродолжить сохранение?",
						"Дата прайняття на роботу співробітника співпадає з датою відркиття вакансії!\nПродовжити збереження?")))
			return false;
		}
		else
		{
			//сохраняем вакансию
			if(dpPers.getCod()>0)
				savePers(fwid_dol,0,bdatLoad,goDay(RBDAT.value,-1));
			else
				savePers(fwid_dol,0,bdatLoad,REDAT.value);
		}
		if(dpPers.getCod()>0)
		{
			//создаем новую запись в ШР
			fwid_dol = GetUID();
			var l = new Object();
			l.FWID = fwid_dol;
			l.FOKLAD = ROKLAD.value;
			l.FSHPZ = dpShifPZ.getFshpz();
			l.FWID_ORG = param.fwid_podr;
			l.FWID_CL = dpDol.getFWID_CL();
			l.FCOD = dpDol.getCod();
			l.FBDAT = RBDAT.value;
			l.FEDAT = REDAT.value;
			UpdateTable("^stru_dol", l, true);
			
			var m = new Object();
			m.FWID_CL = Number(dpPers.getFWID());
			m.FWID_KAT = dpKodKat.getFWID();
			m.FWID_ZVAN = dpKodZvan.getFWID();
			m.FWID_DOL = fwid_dol;
			m.FVOPL = dpVopl.getVopl();
			var snap = getSnap("SELECT MAX(Fid) FROM ^work_pers WHERE Fwid_cl=" + sqlTo(m.FWID_CL));
			if (snap != null)
				m.FID = snap[0] + 1;
			else
				m.FID = 1;	
			m.FWID = GetUID();
			//чтоб сохранились расширения
			extPar.fwid = m.FWID;
			m.FBDAT = RBDAT.value;
			m.FEDAT = REDAT.value;;
			m.FAVANS = RAVANS.value;
			m.FTABLE = RTABLE.value;
			m.FNAZN = RNAZN.value;
			m.FNEWRM = RNEWRM.value;
			m.FDTNEWRM = RDTNEWRM.value;			
			m.FINVAL = RINVAL.value;
			m.FPENS = RPENS.value;
			m.FIS_NAZN = RPRIEM.value;
			m.FIS_UV = RUVOL.value;
			m.FIS_SERV = RZAPIS.value;
			m.FTERM = RTERM.value;
			m.FREASON = RREASON.value;
			m.FREASON_UV = RREASON_UV.value;
			m.FREASON_UVST = oStatUv.getCod();
			m.FKOD_UV = Number(RKOD_UV.value);
			m.FCOD_SSV = dpSSV.getCod();
			m.FCOD_KZO = dpKZO.getCod();
			m.FCOD_SST = dpSST.getCod();
			m.FISMAIN = RISMAIN.value;
			m.FKOLST = RKOLST.value;
			m.FISTRSOG = RTRSOG.value;
			m.FFIKSSUM = RFIKSSUM.value;
			m.FBASEMIND = RBASEMIND.value;
			m.FPREWOKL = RPREWOKL.value;	
			UpdateTable("^work_pers", m, true);
			//savePers(GetUID(),dpPers.getFWID(),RBDAT.value,REDAT.value,true)
		}
	}
	else
	{
		savePers(fwid_dol,dpPers.getFWID(),RBDAT.value,REDAT.value);
	}
}

function savePers(fwid_dol,fwid_cl,bdat,edat)
{
	var l = new Object();
	l.FWID = fwid_dol;
	l.FOKLAD = ROKLAD.value;
	l.FSHPZ = dpShifPZ.getFshpz();
//	if (isNewPost)
//	{
	l.FWID_ORG = param.fwid_podr;
	l.FWID_CL = dpDol.getFWID_CL();
	l.FCOD = dpDol.getCod();
	l.FBDAT = bdat;
	l.FEDAT = edat;
		//l.FEDAT = d00;
//	}
	var ok = UpdateTable("^stru_dol", l, isNewPost);
	if(!ok)
		return false;	
	
	var m = new Object();
	m.FWID_CL = Number(fwid_cl);
	m.FWID_KAT = dpKodKat.getFWID();
	m.FWID_ZVAN = dpKodZvan.getFWID();
	m.FWID_DOL = fwid_dol;
	m.FVOPL = dpVopl.getVopl();
		
    if(mode.indexOf("ADD")>-1)
    {
		var snap = getSnap("SELECT MAX(Fid) FROM ^work_pers WHERE Fwid_cl=" + sqlTo(m.FWID_CL));
		if (snap != null)
			m.FID = snap[0] + 1;
		else
			m.FID = 1;	
		m.FWID = GetUID();
		//чтоб сохранились расширения
		extPar.fwid = m.FWID;
    }
    else
    {
    	m.FWID = param.fwid;
    }
    
	//if(RESTORE.checked==true)
	//	m.FWID = FWID_WP.value;
	
	
	if(getPar("TABNORG") && mode.indexOf("ADD")!=-1 && codorg && ISVAKANS.value == false)
	{
		//записываем в счетчик значение большего номера
		if(mode == "MASS_ADD")
			m.FTABNORG = getNextTabnOrg(param.fwid_podr)
		else
			m.FTABNORG = Number(RTABNORG.value);
		var counter = Number(String(m.FTABNORG).substr(codorg.length));
		var snap = getSnap("select Ftabncounter from ^stru_org where Fwid="+param.fwid_podr);
		if(snap && counter>snap[0])
			ExecuteSQL("update ^stru_org set Ftabncounter="+counter+" where Fwid="+param.fwid_podr);
	}
	m.FBDAT = bdat;
	m.FEDAT = edat;
	m.FAVANS = RAVANS.value;
	m.FTABLE = RTABLE.value;
	m.FNAZN = RNAZN.value;
	m.FNEWRM = RNEWRM.value;
	m.FDTNEWRM = RDTNEWRM.value;	
	m.FINVAL = RINVAL.value;
	m.FPENS = RPENS.value;
	m.FIS_NAZN = RPRIEM.value;
	m.FIS_UV = RUVOL.value;
	m.FIS_SERV = RZAPIS.value;
	m.FTERM = RTERM.value;
	m.FREASON = RREASON.value;
	m.FREASON_UV = RREASON_UV.value;
	m.FREASON_UVST = oStatUv.getCod();
	m.FKOD_UV = Number(RKOD_UV.value);
	m.FCOD_SSV = dpSSV.getCod();
	m.FCOD_KZO = dpKZO.getCod();
	m.FCOD_SST = dpSST.getCod();
	m.FISMAIN = RISMAIN.value;
	m.FKOLST = RKOLST.value;
	m.FISTRSOG = RTRSOG.value;
	m.FFIKSSUM = RFIKSSUM.value;
	m.FBASEMIND = RBASEMIND.value;
	m.FPREWOKL = RPREWOKL.value;
	//для принятых на работу будем проставлять в справочнике дату принятия, если она там остутствует
	if(toScrObj(RPRIEM.value) && m.FID == 1)
	{
		var snap = getSnap("select Fwrkdat from ^cl_homo where Fwid_cl="+fwid_cl);
		if(snap && differ(snap[0],d00)==0)
		{
			var oCl = new DpClEx("CL3",getPar("CODPERS"));
			oCl.loadByID(fwid_cl);
			oCl.setVar("HWRKDAT",bdat);
			oCl.save();
		}
	}
	return UpdateTable("^work_pers", m, mode != "EDIT");
}

function bdatValid()
{
	if (differ(RBDAT.getValue(), d00) == 0)
	{
		WAIT(UR("Дата початку не може бути порожня!|Дата начала не может быть пустой!"));
		return false;
	}
	return dpDol.setDate(RBDAT.getValue());
	//return true;
}

function edatValid()
{
	if(differ(new Date(REDAT.getValue()),new Date(RBDAT.getValue()))>=0)
		return true;
	else
	{
		WAIT(ru("Дата ліквідації не повинна бути меншою за дату призначення!",
				"Дата ликвидации не должна быть меньше даты назначения!"));
		return false;
	}
}

function checkValid()
{
	dpDol.setIsNewPost(ISNEWDOL);
	/*
	if (!list.isSaving())
	{
		Enable(ROKLAD, true);
		Enable(RSHPZ, true);
		ROKLAD.setValue(0);
		dpShifPZ.setFshpz(0);
	}
	
	
	if (dpDol.getCod() == 0)
		lowDat = null;
	else
	{
		if (NEWDOL.value == true)
		{
			if (lowDat != null)
			{
				tmpLowDat = lowDat;
				lowDat = null;
			}
		}
		else
		{
			lowDat = tmpLowDat;
			tmpLowDat = null;
		}
	}*/
}

function isvakansValid()
{
	if(ISVAKANS.value == true)
	{
		RTABN.enabled = false;
		RTABNORG.value = 0;
		dpPers.setCod(0);
	}
	else
	{
		RTABN.enabled = true;
	}
}

function priemValid()
{
//	if(mode == "EDIT" && RPRIEM.value == true)
//	{
//		if(param.fid > 1)
//		{
//			var snap = getSnap("select MIN(Fbdat), Fis_nazn, Fedat from ^work_pers where Fwid_cl="+sqlTo(fwid_cl)
//						+" AND Fid<"+sqlTo(param.fid)+" group by Fis_nazn, Fedat");
//			if(snap)
//			{
//				if(snap[1])
//				{
//					WAIT(ru("Признак принятия на работу уже поставлен в записи за ",
//							"Ознаку прийняття на роботу вже проставлено в запису за ")
//							+format("dd.mm.yy",snap[0])+" - "+format("dd.mm.yy",snap[2]));
//					return false;
//				}
//				else
//				{
//					if(confirm(ru("Признак принятия на работу нужно поставить в самой первой записи за ",
//							"Ознаку прийняття на роботу потрібно поставити в самому першому запису за ")
//							+format("dd.mm.yy",snap[0])+" - "+format("dd.mm.yy",snap[2])
//							+ru("\nПроставить этот признак в первой записе?","\nПроставити цю ознаку в першому запису?")))
//					{
//						ExecuteSQL("update ^work_pers set fis_nazn="+sqlTrue+" where Fwid_cl="+sqlTo(fwid_cl)+" and Fbdat="+sqlTo(snap[0]));
//					}
//					return false;
//				}
//			}
//		}
//	}
	if(RPRIEM.value == true)
		Enable(RTERM);
	else
	{
		RTERM.value = 0;
		Disable(RTERM);
	}
	return true;
}

function uvolValid()
{
	if(toScrObj(RUVOL.value))
	{
		GRP_REASON_UV.visible = true;
	}
	else
	{
		GRP_REASON_UV.visible = false;
	}
}

function condition(cod)
{
	var strSQL = "SELECT MAX(fedat)"
				+ " FROM ^work_pers"
				+ " WHERE fwid_cl=(SELECT MAX(fwid_cl) FROM ^clrelclcl"
								+ " WHERE fcod=" + sqlTo(cod) 
									+  " AND fcl=" + sqlTo(codPers) + ")";
	var snap = getSnap(strSQL);
	if (snap == null || snap[0] == null || snap[0] != d00)
		return true;		
	return false;
}

/*function createNewDol()
{
	return -1;
	var par = new Object();
	par.outValue = true;
	par.sMode = "ADD";
	par.fwid = param.fwid_podr;
	par.bdat = RBDAT.value;
	par.cod = dpDol.getCod();
	showWindow("e_dol.xml", SW_MODAL, par);
	if (!par.escape)
	{
		lowDat = RBDAT.value;
		if (bdatValid())
			return par.fwid;
	}
	return null;
}

function findFreeDol()
{
	if (NEWDOL.value == true)
		return createNewDol();
	var table = OpenTable("m", "SELECT dol.fwid AS fwid FROM ^stru_dol AS dol WHERE dol.fwid_cl=" + sqlTo(dpDol.getFWID())
					+ " AND dol.fedat=" + SqlMaxDate
					+ " AND dol.fwid_org=" + sqlTo(Number(param.fwid_podr))
					+ " AND (((SELECT MAX(fedat) FROM ^work_pers WHERE fwid_dol=dol.fwid) IS NULL)"
					+ " OR (((SELECT MAX(fedat) FROM ^work_pers WHERE fwid_dol=dol.fwid)<>" + SqlMaxDate + ")"
					+ " AND ((SELECT MAX(fedat) FROM ^work_pers WHERE fwid_dol=dol.fwid)<" + sqlTo(RBDAT.value) + ")))");
	if (table.getRecordCount() <= 0)
		return createNewDol();
	table.MoveFirst();
	var fwid = null;
	if (table.getRecordCount() == 1)
	{
		fwid = table.getValue("fwid");
	}
	else
	{
		fwid = table.getValue("fwid");
//		var par = new Object();
//		par.codDol = dpDol.getCod();
//		par.fwid_org = Number(param.fwid_podr);
//		par.ret = new Object();
//		par.ret.fwid = null;
//		showWindow("l_free_dol.xml", SW_MODAL, par);
//		if (!par.escape)
//			fwid = par.ret.fwid;
	}
	if (fwid == null || !setLowDate(fwid))
		return null;
	return fwid;		
}*/

function validAvans(fwid_dol)
{
	//var snap = getSnap("SELECT foklad FROM ^stru_dol WHERE fwid=" + sqlTo(Number(fwid_dol)));
	var snap = new Object();
	snap[0] = ROKLAD.getValue();
	if (snap == null)
	{
		alert(UR("Помилка даних. Не знайдено запису!|Ошибка данных. Запись не найдена!"), ICON_ERROR);
		return false;
	}

	if (Number(RAVANS.value) > Number(snap[0]) && snap[0]>0)
	{
		alert(UR("Оклад складає " + snap[0] + " грн.\nАванс не може бути більшим за оклад!|"
			+ "Оклад составляет " + snap[0] + " грн.\nАванс не может быть больше оклада!"), ICON_WARNING);
		setFocus(RAVANS);
		return false;
	}
	return true;
}

function setLowDate(fwid_dol)
{
	isnew = false;
	var snap = null;
	if (mode == "EDIT")
	{
		var count = getSnap("SELECT COUNT(*) FROM ^work_pers WHERE fwid_dol=" + sqlTo(Number(fwid_dol)))[0];
		if (count <= 1)
		{
			//snap = getSnap("SELECT fbdat FROM ^stru_dol WHERE fwid=" + sqlTo(Number(fwid_dol)));
			snap = getSnap("SELECT fbdat FROM ^stru_org"
							+ " WHERE fwid=(SELECT fwid_org FROM ^stru_dol"
								+ " WHERE fwid=" + sqlTo(Number(fwid_dol)) + ")");
			isnew = true;
		}		
	}
	if (snap == null)
	{	
		var snap = getSnap("SELECT MAX(fedat) AS fedat FROM ^work_pers WHERE fwid_dol=" + sqlTo(Number(fwid_dol)));
		if (snap == null)
		{
			alert(UR("Помилка даних. Не знайдено запису!|Ошибка данных. Запись не найдена!"), ICON_ERROR);
			return false;
		}
		
		if (snap[0] == null || differ(toScriptDate(d00), toScriptDate(snap[0])) == 0)
		{
			//snap = getSnap("SELECT fbdat FROM ^stru_dol WHERE fwid=" + sqlTo(Number(fwid_dol)));
			snap = getSnap("SELECT fbdat FROM ^stru_org"
							+ " WHERE fwid=(SELECT fwid_org FROM ^stru_dol"
								+ " WHERE fwid=" + sqlTo(Number(fwid_dol)) + ")");
			isnew = true;
		}
	}


	if(snap!=null)
	{
		var tmp = toScriptDate(snap[0]);
		var year = tmp.getFullYear();
		var month = tmp.getMonth();	
		var date = tmp.getDate() + (isnew ? 0 : 1);
		lowDat = new Date(year, month, date);
	}	
	return bdatValid();
}

function resetLowDat()
{
	lowDat = null;
}

function fcod_Valid()
{
	/*if (mode == "EDIT" && NEWDOL.value == false)
		return true;
	var dolFWID = findFreeDol(false);
	if (dolFWID == null || dolFWID == -1)
		return true;
	var snap = getSnap("SELECT foklad, fshpz FROM ^stru_dol WHERE fwid=" + sqlTo(dolFWID));
	if (snap == null)
		return true;
	ROKLAD.setValue(snap[0]);
	dpShifPZ.setFshpz(snap[1]);
	Disable(ROKLAD, RSHPZ);*/
	return true;		
}

function tabn_Valid()
{
	if(RINVAL.value == false)
		checkInval();
	if(RPENS.value == false)
		checkPens();
	return true;
}

/*function restore_Valid()
{
	if(RESTORE.checked==true)
		Enable(FWID_WP);
	else
		Disable(FWID_WP);
	return true;
}*/

function fwid_wp_Valid()
{
	if(FWID_WP.value == 0)
	{
		alert(ru("Fwid не может быть нулевым!","Fwid не може бути нульовим!"))
		return false;
	}
	var snap = getSnap("SELECT * FROM ^work_pers WHERE fwid="+sqlTo(FWID_WP.value));
	if(snap==null)
		return true;
	else
	{
		alert(ru("Такой fwid уже существует!","Такий fwid вже існує!"));
		return false;
	}
}

//проверяем наличие признака инвалидности в справочнике персонала
function checkInval()
{
	var snap = getSnap("select Finval,Fbdatinval,Fedatinval from ^persfile where Fwid_cl="+dpPers.getFWID());
	if(snap)
	{
		msg = ru("В личной карточке сотрудника проставлен признак инвалидности с "+format("dd.mm.yy",snap[1])+(differ(d00,snap[2])==0?"":format(" по dd.mm.yy",snap[2]))+"\nПроставить этот признак в штатном расписании?",
				"В особовій картці співробітника проставлено ознаку інвалідності з "+format("dd.mm.yy",snap[1])+(differ(d00,snap[2])==0?"":format(" по dd.mm.yy",snap[2]))+"\nПроставити цю ознаку в штатному розкладі?")
		if(snap[0]==true && differ(snap[2],RBDAT.value)>=0 && differ(snap[1],REDAT.value)<=0 && confirm(msg))
			RINVAL.value = true;
	}
}

//проверяем наличие признака пенсионера в справочнике персонала
function checkPens()
{
	var snap = getSnap("select Fpens,Fbdatpens from ^persfile where Fwid_cl="+dpPers.getFWID());
	if(snap)
	{
		msg = ru("В личной карточке сотрудника проставлен признак пенсионера с "+format("dd.mm.yy",snap[1])+"\nПроставить этот признак в штатном расписании?",
				"В особовій картці співробітника проставлено ознаку пенсіонера з "+format("dd.mm.yy",snap[1])+"\nПроставити цю ознаку в штатному розкладі?")
		if(snap[0]==true && differ(snap[1],REDAT.value)<=0 && confirm(msg))
			RPENS.value = true;
	}
}

function invalValid()
{
	if(mode == "ADD" && RINVAL.value == true)
	{
		if(dpSSV.getCod()==0)
			dpSSV.setCod(2);
		if(dpKZO.getCod()==0)
			dpKZO.setCod(2);
	}
	else
	{
		if(dpSSV.getCod()==0)
			dpSSV.setCod(1);
		if(dpKZO.getCod()==0)
			dpKZO.setCod(1);
	}
	return true;
}

function tabnorgValid()
{
	if(RTABNORG.value == 0)
	{
		WAIT(ru("Укажите табельный номер в разрезе подразделений!","Вкажіть табельний номер у розрізі підрозділів!"));
		return false;
	}
	//проверяем чтоб первые цифры относились к коду подразделения
	var snap = getSnap("select Flv1,Flv2,Flv3,Flv4 from ^stru_org where Fwid="+param.fwid_podr);
	if(snap && snap[0])
	{
		if(!codorg)
			codorg = String(snap[0])+(snap[1]!=0?(snap[1]+(snap[2]!=0?(snap[2]+(snap[3]!=0?snap[3]:"")):"")):"");
		if(String(RTABNORG.value).substr(0,codorg.length)!=codorg)
		{
			WAIT(ru("Таб.номер по подразделению должен начинаться с "+codorg,"Таб.номер по підрозділу повинен починатись з "+codorg));
			return false;
		}
		if(String(RTABNORG.value).length<codorg.length+3)
		{
			WAIT(ru("Таб.номер по подразделению должен быть не меньше "+(codorg.length+3)+" символов","Таб.номер по підрозділу повинен бути не меншим "+(codorg.length+3)+" символів"));
			return false;
		}
	}
	var snap = getSnap("select Fwid from ^work_pers where Ftabnorg="+RTABNORG.value+(mode=="EDIT"?" and Fwid<>"+param.fwid:""));
	if(snap && snap[0] && RZAPIS.value==false)
	{
		WAIT(ru("Такой номер уже сущесвтует!","Такий номер вже існує!"));
		return false;
	}
	dpPers.setDefCod(RTABNORG.value);
	return true;
}

function init_RTABLE()
{
	RTABLE.addItem(1, "1: "+getTxtKatPersTbl5(1));
	RTABLE.addItem(2, "2: "+getTxtKatPersTbl5(2));
}

include("sys\\DpBaseDlg.js");