//экспорт всех таблиц персонификации в dbf
include("Objects/DpGetDat.js");
include("servis/zrp.js");

function Load(mode)
{
	var gd = new DpGetDat("d");
	if(gd.escape)
		return false;
	var szTag = getDateTag(gd.dat1);
	var zppnm5 = "^ZPPNMV"+szTag;
	var zppnm6 = (mode!="2011"?"^ZPPNMVI":"^ZPPMVI")+szTag;
	if (mode=="2013"){
		var zppnm6 = "^ZPPFMVI"+szTag;		
	}
	var zppnm7 = "^ZPPNMVII"+szTag;
	//var zppnm7d = "^ZPPNMVIID"+szTag;
	var zppnm8 = "^ZPPNMVIII"+szTag;
	var lastDir = ReadParEx("sDir");
	var sDir = BrowseForDir(lastDir, ru("Экспорт в dbf","Експорт в dbf"), ru("Укажите директорию экспорта","Вкажіть директорію експорту"));
	if(!sDir)
		return false;
	// в папке экспорта очищаем от всех dbf
	var tblFilesName = snapDirectory(sDir, "*.dbf");
	for (var i in tblFilesName)
	{
		var fileName = String(tblFilesName[i]);
		var fileExt = fileName.substr(fileName.length-3, fileName.length);
		if (fileExt == "dbf")
		{
			deleteFile(sDir + fileName);
		}
	}
	WriteParEx("sDir",sDir);
	expToDbfMonthPers(zppnm5, null, sDir, gd.dat1, mode);
	expToDbfMonthPers(zppnm6, null, sDir, gd.dat1, mode);
	if(mode!="2011")
		expToDbfMonthPers(zppnm7, null, sDir, gd.dat1, mode);
	expToDbfMonthPers(zppnm8, null, sDir, gd.dat1, mode);
	return true;		
}

Load(GetMenuMode())